/*
 * This file is (C) Chris Wohlgemuth 1999
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "audiofolder.hh"
#include "audiofolderhelp.h"

#include <stdlib.h>
#include <stdio.h>

PVOID pvAudioSharedMem=NULL;
BOOL setupDone=FALSE;
BOOL GrabberSetupDone=FALSE;
BOOL bGrabberFirst=FALSE;

int iNumCD;
char cFirstCD;
char chosenCD[3];
char chosenWriter[3];// Drive letter of CD-writer

char chrMpg123Path[CCHMAXPATH];
BOOL bMpg123SwabBytes;

char chrGrabberPath[CCHMAXPATH];
char chrGrabberOptions[CCHMAXPATH];
char chrAudioCDROptions[CCHMAXPATH];
int bTrackNumbers;

char chrCDRecord[CCHMAXPATH]={0};/* Path to cdrecord */
char chrDataCDROptions[CCHMAXPATH]={0};
LONG  lCDROptions=0;

char chrCdrdaoPath[CCHMAXPATH]={0};
char chrCdrdaoDriver[100]={0};
char chrDeviceName[CCHMAXPATH]={0};
char chrWriterName[CCHMAXPATH]={0};

int iBus=0;
int iTarget=0;
int iLun=0;
int iSpeed=1;
int iFifo=4;

char chrInstallDir[CCHMAXPATH]={0};

ATOM atomUpdateStatusbar;
ATOM atomStartGrab;
ATOM atomStartWrite;

/* This is the handle for the ressource DLL holding the NLS messages and dialogs */
HMODULE hAudioResource=NULLHANDLE;

HMODULE queryModuleHandle(void);
void _Optlink toolsThreadFunc (void *arg);
void sendConfig();
void errorResource();
void getMessage(char* text,ULONG ulID, LONG lSizeText, HMODULE hResource,HWND hwnd);
ULONG messageBox( char* text, ULONG ulTextID , LONG lSizeText,
                  char* title, ULONG ulTitleID, LONG lSizeTitle,
                  HMODULE hResource, HWND hwnd, ULONG ulFlags);

MRESULT EXPENTRY selectDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY statusLineDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY dialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY grabDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);


/* Not used yet!!!!!!!!!!!!!!!!! */
void readIni()
{
  ULONG keyLength;
  char profileName[CCHMAXPATH];
  char moduleName[CCHMAXPATH];
  char *chrPtr;
  HINI hini=0;
  char    text[200];
  ULONG ulSize;
  int a;
  char chrCD[4];

  /*bShowGrab=FALSE;*/

  /* Query the number of CD-drives */
  /*  cwQueryCDDrives(&iNumCD,&cFirstCD);
   */
  
  /* Get folder of class-dll. */
  DosQueryModuleName(queryModuleHandle(),sizeof(moduleName),moduleName);
  chrPtr=strrchr(moduleName,'\\');
  if(chrPtr)
    *chrPtr=0;
  /* Save install dir */
  sprintf(chrInstallDir,"%s",moduleName);
  /* Build full path for cdrecord.ini file */
  sprintf(profileName,"%s\\cdrecord.ini",moduleName);       
  /* Open ini-file */
  hini=PrfOpenProfile(WinQueryAnchorBlock(HWND_DESKTOP),profileName);
  do{
    if(!hini) {
      /* profileName: "Warning! Cannot open Ini-file!"
         moduleName: "Audio-CD-Creator"
         */
      messageBox( profileName, IDSTR_INIFILEOPENERROR , sizeof(profileName),
                  moduleName, IDSTR_AUDIOCDCREATOR, sizeof(moduleName),
                  hAudioResource, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
      break;
    }/* end of if(!hini) */
    
    keyLength=PrfQueryProfileString(hini,"CDWriter","cdrecord","",chrCDRecord,sizeof(chrCDRecord));

    if(keyLength!=1){
      PrfQueryProfileString(hini,"CDWriter","audiocdroptions","",chrAudioCDROptions,sizeof(chrAudioCDROptions));
      ulSize=sizeof(lCDROptions);
      PrfQueryProfileData(hini,"CDWriter","options",&lCDROptions,&ulSize);
      PrfQueryProfileString(hini,"CDWriter","writedrive","",chosenWriter,sizeof(chosenWriter));
      setupDone=TRUE;
      sendConfig();
    }

    keyLength=PrfQueryProfileString(hini,"CDGrabber","grabber","",chrGrabberPath,sizeof(chrGrabberPath));
    if(keyLength!=1){
     /* We have got entries yet */    
      PrfQueryProfileString(hini,"CDGrabber","graboptions","",chrGrabberOptions,sizeof(chrGrabberOptions));
      PrfQueryProfileString(hini,"CDGrabber","grabdrive","",chosenCD,sizeof(chosenCD));
      bTrackNumbers=PrfQueryProfileInt(hini,"CDGrabber","tracknumbers",1);
      GrabberSetupDone=TRUE;
    }

    keyLength=PrfQueryProfileString(hini,"mpg123","path","",chrMpg123Path,sizeof(chrMpg123Path));
    if(keyLength!=1){
     /* We have got entries yet */
    }
    bMpg123SwabBytes=PrfQueryProfileInt(hini,"mpg123","swabbytes",1);

    keyLength=PrfQueryProfileString(hini,"cdrdao","path","",chrCdrdaoPath,sizeof(chrCdrdaoPath));
    if(keyLength!=1){
     /* We have got entries yet */
    }

    keyLength=PrfQueryProfileString(hini,"cdrdao","driver","",chrCdrdaoDriver,sizeof(chrCdrdaoDriver));
    if(keyLength!=1){
     /* We have got entries yet */
    }

    keyLength=PrfQueryProfileString(hini,"cdrdao","writer","",chrWriterName,sizeof(chrWriterName));
    if(keyLength!=1){
     /* We have got entries yet */
    }

    iBus=PrfQueryProfileInt(hini,"device","bus",0);
    iTarget=PrfQueryProfileInt(hini,"device","target",0);
    iLun=PrfQueryProfileInt(hini,"device","lun",0);
    iSpeed=PrfQueryProfileInt(hini,"device","speed",1);
    iFifo=PrfQueryProfileInt(hini,"device","fifo",4);
    
    keyLength=PrfQueryProfileString(hini,"device","devicename","",chrDeviceName,sizeof(chrDeviceName));

    break;
  } while(TRUE);
  if(hini)PrfCloseProfile(hini);
  /*  return CWProgFolder::wpRestoreState(ulReserved);
   */
}

BOOL CWAudioFolder::wpSetupOnce(PSZ pSetupString)
{
  /**************************************************
   *                                                *
   * Supported setupstrings:                        *
   *       FLDRWRITEFLAGS=1+2+4+8                   *
   *                                                *
   **************************************************/
  BOOL rcParent;
  char buffer[CCHMAXPATH];
  ULONG bufferSize;

  rcParent=((somTD_WPObject_wpSetupOnce)
            somParentNumResolve(__ClassObject->somGetPClsMtabs(),
                                1,
                                __ClassObject->
                                somGetMethodToken(somIdFromString
                                                  ("wpSetupOnce")))                  
            )(this,pSetupString);
  /* Doing our own setup here */
  bufferSize=sizeof(buffer);
  if(!wpScanSetupString(pSetupString,"ICONVIEW",buffer,&bufferSize))
    wpSetup( "ICONVIEW=NONFLOWED,MINI");/* Fill in defaults */
  bufferSize=sizeof(buffer);
  if(!wpScanSetupString(pSetupString,"ICONVIEWPOS",buffer,&bufferSize))
    wpSetup( "ICONVIEWPOS=20,15,80,60");/* Fill in defaults */
  bufferSize=sizeof(buffer);
  if(!wpScanSetupString(pSetupString,"FLDRWRITEFLAGS",buffer,&bufferSize))
    ulWriteFlags=IDWF_PAD|IDWF_NOFIX|IDWF_DUMMY; /* No key, set defaults */
  else
    wpSetup(pSetupString);
  readIni();
  return rcParent;
}

BOOL CWAudioFolder::wpSetup(PSZ pSetupString)
{
  /**************************************************
   *                                                *
   * Supported setupstrings:                        *
   *       FLDRWRITEFLAGS=1+2+4+8                   *
   *                                                *
   **************************************************/
  char buffer[CCHMAXPATH];
  ULONG bufferSize;
  ULONG ulWFlags;

  bufferSize=sizeof(buffer);
  if(wpScanSetupString(pSetupString,"FLDRWRITEFLAGS",buffer,&bufferSize))
    { 
      ulWFlags=atol(buffer);
      cwSetWriteFlags( ulWFlags,WF_ALLFLAGS);
    }
  bufferSize=sizeof(buffer);
  if(wpScanSetupString(pSetupString,"DISPLAYHELPPANEL",buffer,&bufferSize))
    { 
      ulWFlags=atol(buffer);
      wpDisplayHelp(ulWFlags,AFHELPLIBRARY);
    }
  bufferSize=sizeof(buffer);
  if(wpScanSetupString(pSetupString,"FREESHAREDMEM",buffer,&bufferSize))
    { 
      ulWFlags=atol(buffer);
      if(ulWFlags==1)
        DosFreeMem(pvAudioSharedMem);
      pvAudioSharedMem=NULL;
    }
  return CWProgFolder::wpSetup(pSetupString);
}

void CWAudioFolder::wpCopiedFromTemplate()
{
  wpSetup("ICONVIEW=NONFLOWED,MINI;ICONVIEWPOS=20,15,50,80");

  CWProgFolder:: wpCopiedFromTemplate();
}


/************************************************/
/* Override function: Remove the tree view page */
/************************************************/
ULONG CWAudioFolder::wpAddFolderView2Page(HWND hwndNotebook)
{
  return SETTINGS_PAGE_REMOVED;
}


BOOL CWAudioFolder::wpAddSettingsPages(HWND hwndNotebook)
{
  BOOL rc;

  /* Call the parent so it can insert its settings pages */
  rc=((somTD_WPObject_wpAddSettingsPages)
      somParentNumResolve(__ClassObject->somGetPClsMtabs(),
                          1,
                          __ClassObject->
                          somGetMethodToken(somIdFromString
                                            ("wpAddSettingsPages")))
      )(this,hwndNotebook);

  if(!hAudioResource) {
    errorResource();
    return rc;
  }
  
  /*if(bGrabberFirst)
    rc && AddCdrecordOptionPage(hwndNotebook)
      && AddGrabOptionPage(hwndNotebook);
  else*/
    rc && AddMpg123OptionPage(hwndNotebook)
      && AddGrabOptionPage(hwndNotebook)
      && AddCdrdaoOptionPage(hwndNotebook)
      && AddCdrecordOptionPage(hwndNotebook)
      && cwAddGeneralOptionPage(hwndNotebook);
    
  return rc;
  // Durch obige Konstruktion wird die Elternmethode des direkten Vorgngers aufgerufen,
  // und nicht die ursprngliche von WPLaunchPad, falls WPLaunchPad replaced wurde.
  // Durch diesen Aufruf gehen eventuelle Erweiterungen durch Vererbung verloren:
  //            < return WPLaunchPad::wpMenuItemSelected(hwndFrame, ulMenuId); >
  // Dieser Aufruf macht Ergnzungen in wpobject.hh erforderlich!!! Wird durch ein VAC-Fixpack vielleicht spter
  //erledigt    
}

/************************************************/
/* Override function: Remove the tree view open */
/*                    item from the menu.       */
/************************************************/
ULONG CWAudioFolder::wpFilterPopupMenu(ULONG ulFlags, HWND hwndCnr, BOOL fMultiSelect)
{
  return CWProgFolder::wpFilterPopupMenu( ulFlags, hwndCnr, fMultiSelect) & ~CTXT_TREE;
}

/************************************************/
/* Override function:                           */
/************************************************/
BOOL CWAudioFolder::wpModifyPopupMenu(HWND hwndMenu, HWND hwndCnr, ULONG ulPosition)
{
  /* Remove the change to tree view item from menu */ 
  /* This does not remove it from the menubar :( */
  WinSendMsg(hwndMenu,MM_REMOVEITEM,MPFROM2SHORT(717,TRUE),0);

  if(hAudioResource) {
    wpInsertPopupMenuItems(hwndMenu,1,hAudioResource,ID_MENUTOOLS,0);
    wpInsertPopupMenuItems(hwndMenu,-1,hAudioResource,ID_MENUABOUT,WPMENUID_HELP);
  }

  return CWProgFolder::wpModifyPopupMenu(hwndMenu, hwndCnr,  ulPosition); 
}

BOOL CWAudioFolder::wpMenuItemSelected(HWND hwndFrame,ULONG ulMenuId)
{
  int tid;

  switch(ulMenuId)
    {
    case 717://Change to tree view
      DosBeep(100,100);
      return TRUE;
    case ID_TOOLSITEM:
      tid=_beginthread(toolsThreadFunc,NULL,8192*8,this); //Fehlerbehandlung fehlt
      return TRUE;
    case ID_ABOUTITEM:
      cwShowAboutDlg(hAudioResource,IDDLG_ABOUT);
      return TRUE;
    default:
      break;
    }

  return CWProgFolder::wpMenuItemSelected( hwndFrame, ulMenuId);
}


BOOL CWAudioFolder::wpMenuItemHelpSelected(ULONG MenuId)
{
  switch(MenuId) {
  case ID_TOOLSITEM:
    return wpDisplayHelp(ID_TOOLSITEM,AFHELPLIBRARY);       
  case ID_ABOUTITEM:
    return FALSE;
  default:
    break;
  }
  return CWProgFolder::wpMenuItemHelpSelected(MenuId);
}


/* This function is called when the object is created from a 
   template, too */
BOOL CWAudioFolder::wpRestoreState(ULONG ulReserved)
{
  ULONG keyLength;
  char profileName[CCHMAXPATH];
  char moduleName[CCHMAXPATH];
  char *chrPtr;
  HINI hini=0;
  char    text[200];
  ULONG ulSize;
  int a;
  char chrCD[4];

  bShowGrab=FALSE;

  /* Query the number of CD-drives */
  cwQueryCDDrives(&iNumCD,&cFirstCD);
  
  /* Restore write flags */
  if(!wpRestoreLong("CWAudioFolder",IDKEY_FDRWRITEFLAGS,&ulWriteFlags))
    ulWriteFlags=IDWF_PAD|IDWF_NOFIX|IDWF_DUMMY;
  
  /* Get folder of class-dll. */
  DosQueryModuleName(queryModuleHandle(),sizeof(moduleName),moduleName);
  chrPtr=strrchr(moduleName,'\\');
  if(chrPtr)
    *chrPtr=0;
  /* Save install dir */
  sprintf(chrInstallDir,"%s",moduleName);
  /* Build full path for cdrecord.ini file */
  sprintf(profileName,"%s\\cdrecord.ini",moduleName);       
  /* Open ini-file */
  hini=PrfOpenProfile(WinQueryAnchorBlock(HWND_DESKTOP),profileName);
  do{
    if(!hini) {
      /* profileName: "Warning! Cannot open Ini-file!"
         moduleName: "Audio-CD-Creator"
         */
      messageBox( profileName, IDSTR_INIFILEOPENERROR , sizeof(profileName),
                  moduleName, IDSTR_AUDIOCDCREATOR, sizeof(moduleName),
                  hAudioResource, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
      break;
    }/* end of if(!hini) */
    
    keyLength=PrfQueryProfileString(hini,"CDWriter","cdrecord","",chrCDRecord,sizeof(chrCDRecord));

    if(keyLength!=1){
      PrfQueryProfileString(hini,"CDWriter","audiocdroptions","",chrAudioCDROptions,sizeof(chrAudioCDROptions));
      ulSize=sizeof(lCDROptions);
      PrfQueryProfileData(hini,"CDWriter","options",&lCDROptions,&ulSize);
      PrfQueryProfileString(hini,"CDWriter","writedrive","",chosenWriter,sizeof(chosenWriter));
      setupDone=TRUE;
      sendConfig();
    }

    keyLength=PrfQueryProfileString(hini,"CDGrabber","grabber","",chrGrabberPath,sizeof(chrGrabberPath));
    if(keyLength!=1){
     /* We have got entries yet */    
      PrfQueryProfileString(hini,"CDGrabber","graboptions","",chrGrabberOptions,sizeof(chrGrabberOptions));
      PrfQueryProfileString(hini,"CDGrabber","grabdrive","",chosenCD,sizeof(chosenCD));
      bTrackNumbers=PrfQueryProfileInt(hini,"CDGrabber","tracknumbers",1);
      GrabberSetupDone=TRUE;
    }

    keyLength=PrfQueryProfileString(hini,"mpg123","path","",chrMpg123Path,sizeof(chrMpg123Path));
    if(keyLength!=1){
     /* We have got entries yet */
    }
    bMpg123SwabBytes=PrfQueryProfileInt(hini,"mpg123","swabbytes",1);

    keyLength=PrfQueryProfileString(hini,"cdrdao","path","",chrCdrdaoPath,sizeof(chrCdrdaoPath));
    if(keyLength!=1){
     /* We have got entries yet */
    }

    keyLength=PrfQueryProfileString(hini,"cdrdao","driver","",chrCdrdaoDriver,sizeof(chrCdrdaoDriver));
    if(keyLength!=1){
     /* We have got entries yet */
    }

    keyLength=PrfQueryProfileString(hini,"cdrdao","writer","",chrWriterName,sizeof(chrWriterName));
    if(keyLength!=1){
     /* We have got entries yet */
    }

    iBus=PrfQueryProfileInt(hini,"device","bus",0);
    iTarget=PrfQueryProfileInt(hini,"device","target",0);
    iLun=PrfQueryProfileInt(hini,"device","lun",0);
    iSpeed=PrfQueryProfileInt(hini,"device","speed",1);
    iFifo=PrfQueryProfileInt(hini,"device","fifo",4);
    
    keyLength=PrfQueryProfileString(hini,"device","devicename","",chrDeviceName,sizeof(chrDeviceName));

    break;
  } while(TRUE);
  if(hini)PrfCloseProfile(hini);
  return CWProgFolder::wpRestoreState(ulReserved);
}

BOOL CWAudioFolder::wpSaveState()
{
  char profileName[CCHMAXPATH];
  char moduleName[CCHMAXPATH];
  char *chrPtr;
  char chrDev[10];
  HINI hini=0;

  /* This saves the instance write flags */
  if(!wpSaveLong("CWAudioFolder",IDKEY_FDRWRITEFLAGS,ulWriteFlags))
    /* profileName: "Warning! Cannot write instance data!"
       moduleName: "Audio-CD-Creator"
       */
    messageBox( profileName, IDSTR_WRITEINSTANCEDATAERROR , sizeof(profileName),
                moduleName, IDSTR_AUDIOCDCREATOR, sizeof(moduleName),
                hAudioResource, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
  
   /* Build the ini-file name */
  /* Get folder of class-dll. */
  DosQueryModuleName(queryModuleHandle(),sizeof(moduleName),moduleName);
  chrPtr=strrchr(moduleName,'\\');
  if(chrPtr)
    *chrPtr=0;
  /* Build full path */
  sprintf(profileName,"%s\\cdrecord.ini",moduleName);       

  /* Global settings are saved in an ini-file */
  do{  
    /* Open the ini-file */
    hini=PrfOpenProfile(WinQueryAnchorBlock(HWND_DESKTOP),profileName);
    if(!hini) {
      /* profileName: "Warning! Cannot open Ini-file!"
         moduleName: "Audio-CD-Creator"
         */
      messageBox( profileName, IDSTR_INIFILEOPENERROR , sizeof(profileName),
                  moduleName, IDSTR_AUDIOCDCREATOR, sizeof(moduleName),
                  hAudioResource, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
      return CWProgFolder::wpSaveState();
    }/* end of if(!hini) */
    /* Save cdrecord-path */
    if(!PrfWriteProfileString(hini,"CDWriter","cdrecord",chrCDRecord)) 
      break;    

    /* Save cdrecord options */
    if(!PrfWriteProfileString(hini,"CDWriter","audiocdroptions",chrAudioCDROptions))    
      break;

    if(!PrfWriteProfileString(hini,"CDWriter","writedrive",chosenWriter))
      break;

    if(!PrfWriteProfileString(hini,"CDGrabber","grabber",chrGrabberPath))    
      break;

    if(!PrfWriteProfileString(hini,"CDGrabber","graboptions",chrGrabberOptions))
      break;
    
    if(!PrfWriteProfileString(hini,"CDGrabber","grabdrive",chosenCD))
      break;

    if(bTrackNumbers) {
      if(!PrfWriteProfileString(hini,"CDGrabber","tracknumbers","1"))
        break;
    }
    else
      if(!PrfWriteProfileString(hini,"CDGrabber","tracknumbers","0"))
        break;

    if(!PrfWriteProfileData(hini,"CDWriter","options",&lCDROptions,sizeof(lCDROptions))) {
      break;
    };

    if(!PrfWriteProfileString(hini,"mpg123","path",chrMpg123Path))
      break;

    if(bMpg123SwabBytes) {
      if(!PrfWriteProfileString(hini,"mpg123","swabbytes","1"))
        break;
    }
    else
      if(!PrfWriteProfileString(hini,"mpg123","swabbytes","0"))
        break;

    if(!PrfWriteProfileString(hini,"cdrdao","path",chrCdrdaoPath))
      break;

    if(!PrfWriteProfileString(hini,"cdrdao","driver",chrCdrdaoDriver))
      break;

    if(!PrfWriteProfileString(hini,"cdrdao","writer",chrWriterName))
      break;
   
    sprintf(chrDev,"%d",iBus);
    if(!PrfWriteProfileString(hini,"device","bus",chrDev))
      break;

    sprintf(chrDev,"%d",iTarget);
    if(!PrfWriteProfileString(hini,"device","target",chrDev))
      break;

    sprintf(chrDev,"%d",iLun);
    if(!PrfWriteProfileString(hini,"device","lun",chrDev))
      break;

    if(!PrfWriteProfileString(hini,"device","devicename",chrDeviceName))
      break;

    sprintf(chrDev,"%d",iSpeed);
    if(!PrfWriteProfileString(hini,"device","speed",chrDev))
      break;

    sprintf(chrDev,"%d",iFifo);
    if(!PrfWriteProfileString(hini,"device","fifo",chrDev))
      break;

    PrfCloseProfile(hini);
    return CWProgFolder::wpSaveState();
  }while(TRUE);
  /* profileName: "Warning! Cannot write to Ini-file!"
     moduleName: "Audio-CD-Creator"
     */
  messageBox( profileName, IDSTR_WRITEINIERROR, sizeof(profileName),
              moduleName, IDSTR_AUDIOCDCREATOR, sizeof(moduleName),
              hAudioResource, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
  if(hini)PrfCloseProfile(hini);
  
  return CWProgFolder::wpSaveState();
}


MRESULT CWAudioFolder::wpDrop(HWND hwndCnr,PDRAGINFO pDragInfo,PDRAGITEM pDragItem)
{
  MRESULT mr;

  mr=CWProgFolder::wpDrop(hwndCnr, pDragInfo, pDragItem);
  cwForceStatusUpdate()   ;       
  return mr;
}


BOOL  CWAudioFolder::wpDeleteFromContent(WPObject* Object)
{
  BOOL rc;    
    
  rc=CWProgFolder::wpDeleteFromContent(Object);
  cwForceStatusUpdate()   ;
  return rc;
}

BOOL CWAudioFolder::wpAddToContent(WPObject* Object)
{
  BOOL rc;
 
  rc=CWProgFolder::wpAddToContent(Object);
  cwForceStatusUpdate()   ;
  return rc;
}

BOOL CWAudioFolder::wpPopulate(ULONG ulReserved,PSZ Folder,BOOL fFoldersOnly)
{
  BOOL rc;

  rc=CWProgFolder::wpPopulate(ulReserved,Folder,fFoldersOnly);

  /* Set total time into status line */
  cwForceStatusUpdate();
  return rc;  
}

HWND CWAudioFolder::wpOpen(HWND hwndCnr,ULONG ulView,ULONG ulParam)
{
  HWND hwnd;
  SIZEL sizelLeft={0};
  HWND myFrameHWND;
  RECTL rectl;
  MENUITEM mi;
  HWND hwndMenu;
  int iItemCount;
  char text[200];

  /* Call parent to build folder window */
  hwnd=CWProgFolder::wpOpen(hwndCnr, ulView, ulParam);
    

  /* Only subclass folder frames, not settings notebooks */
  if(ulView!=OPEN_SETTINGS){
    if(!hAudioResource) {
      errorResource();
      return hwnd;
    }

    myFrameHWND=WinWindowFromID(hwnd,FID_MENU);//Get menu hwnd      
    /* Remove the change to tree view item from menubar */ 
    //WinSendMsg(myFrameHWND,MM_DELETEITEM,MPFROM2SHORT(717,TRUE),0);

    if(myFrameHWND){
      /* Query the number of items in the menubar */
      iItemCount=(int)WinSendMsg(myFrameHWND,MM_QUERYITEMCOUNT,(MPARAM)0,
                                 (MPARAM)0);
      /* Load the Misc-tools menu from the resource */
      hwndMenu=WinLoadMenu(myFrameHWND,hAudioResource,ID_TBMENUTOOLS);
      //723
      if(hwndMenu){
        /* Fill the MENUITEM structure */
        mi.iPosition=iItemCount-1;
        mi.afStyle=MIS_TEXT|MIS_SUBMENU;
        mi.id=ID_TBMENUTOOLS;
        mi.afAttribute=NULL;                
        mi.hwndSubMenu=hwndMenu;
        mi.hItem=NULL;
        /* Add the Misc-tools item to the folder menubar */
        /* Text: "Misc-Tools" */
        getMessage(text, IDSTR_MISCTOOLS,sizeof(text), hAudioResource, hwnd);
        WinSendMsg(myFrameHWND,MM_INSERTITEM,(MPARAM)&mi,
                   (MPARAM)text); 
      }/* end of if(hwndMenu) */
      /*    WinSendMsg(myFrameHWND,MM_QUERYITEM,MPFROM2SHORT(723,FALSE),
            (MPARAM)&mi);*/ 
    }
    /* Now add the framecontrols */

    /* This is the select-frameCtrl. */
    /* Load the dialog from the resource. The object pointer of this
       folder is given to the dialog procedure (this). In WM_INITDLG
       the procedure saves this pointer for later use. */
    myFrameHWND=WinLoadDlg(hwnd,hwnd,selectDialogProc,hAudioResource,IDDLG_SELECTDLG,this);
    /* Save the HWND in the instance data */    
    hwndSelect=myFrameHWND;

    if(tid)     
      /* The folder currently grabs some tracks from CD so disable the controls. */
      cwEnableSelectControls(FALSE);

    if(myFrameHWND){
      /* Query the size of the dialog */
      WinQueryWindowRect(myFrameHWND,&rectl);
      /* It's the top dialog so we need the height but not the width. The width
         is always the width of the folder. */
      sizelLeft.cy=rectl.yTop-rectl.yBottom;
      /* Call a method of CWProgFolder to add the dialog as a framecontrol. 
         FCTL_TOP means put it at the top of the folder.
         After calling cwUpdateFrame(hwnd) it will be visible */
      cwAddFrameCtl(hwnd, myFrameHWND, sizelLeft, FCTL_TOP,0);
    }
        
    if(tid) {
      /* The folder currently grabs some tracks from CD so show grab framecontrol. */
      /* This is the grab-framectrl. */
      myFrameHWND=WinLoadDlg(hwnd,hwnd,grabDialogProc,hAudioResource,IDDLG_GRABDIALOG,this);
      hwndGrab=myFrameHWND;
      cwEnableGrabControls(FALSE);
    }
    else {
      /* This is the write-framectrl. */
      myFrameHWND=WinLoadDlg(hwnd,hwnd,dialogProc,hAudioResource,ID_DIALOG,this);
      hwndWrite=myFrameHWND;
      if(hwndWrite&&tidWrite)
        cwEnableWriteControls(FALSE);
    }
    if(myFrameHWND){
      WinQueryWindowRect(myFrameHWND,&rectl);
      sizelLeft.cx=rectl.xRight-rectl.xLeft;
      /* Put the dialog at the left side of the folder */
      cwAddFrameCtl(hwnd, myFrameHWND, sizelLeft, FCTL_LEFT,FCTL_POSBELOW);
    }
    /* Statusbar */
    hwndStatusFrameCtl=WinLoadDlg(hwnd,hwnd,statusLineDialogProc,hAudioResource,IDDLG_STATUS,this);
    if(hwndStatusFrameCtl) {
      WinQueryWindowRect(hwndStatusFrameCtl,&rectl);
      sizelLeft.cy=rectl.yTop-rectl.yBottom;
      /* Put the dialog at the bottom of the folder */
      cwAddFrameCtl(hwnd, hwndStatusFrameCtl, sizelLeft, FCTL_BOTTOM,0);
    }
    /* Refresh frame to show the new framecontrols */
    cwUpdateFrame(hwnd);
    /* Let the statusbar show the right time */
    cwForceStatusUpdate();
  }
  return hwnd;
}










