/*
 * This file is (C) Chris Wohlgemuth 1999
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include "audiofolder.hh"
#include "audiofolderhelp.h"


#pragma SOMAsDefault(off)
#include <sys\types.h>
#include <sys\stat.h>

#pragma SOMAsDefault(pop)

#include <stdio.h>
#include <stdlib.h>

extern PVOID pvSharedMem;
extern char chrCDRecord[CCHMAXPATH];/* Path to cdrecord */
extern char chrDeviceName[CCHMAXPATH];
extern char chrDataCDROptions[CCHMAXPATH];
extern LONG lCDROptions;
extern int iNumCD;
extern char cFirstCD;
extern char chosenWriter[3];

char chosenMultiSessionCD[3];
BOOL bMultiSessionDone=FALSE;
extern char chrMkisofs[CCHMAXPATH];/* Path to mkisofs */
extern char chrMkisofsOptions[CCHMAXPATH];
extern LONG lMKOptions;
extern BOOL MkisofsSetupDone;
extern char chrImage[CCHMAXPATH];/* Path to iso-image */

extern int iBus;
extern int iTarget;
extern int iLun;
extern int iSpeed;
extern int iFifo;

extern HMODULE hDataResource;

extern BOOL setupDone;

HMODULE queryModuleHandle(void);
ULONG launchMsInfo(HWND hwnd);
ULONG messageBox( char* text, ULONG ulTextID , LONG lSizeText,
                  char* title, ULONG ulTitleID, LONG lSizeTitle,
                  HMODULE hResource, HWND hwnd, ULONG ulFlags);
void getMessage(char* text,ULONG ulID, LONG lSizeText, HMODULE hResource,HWND hwnd);
void sendConfig();
void _Optlink scanbusThreadFunc(void *arg);

/* Local */
void enableCDTypeCntrls(HWND hwnd, CWDataFolder* thisPtr);
MRESULT EXPENTRY imageNameDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) ;
MRESULT EXPENTRY dataCDStatusLineDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY msInfoStatusDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) ;
MRESULT EXPENTRY mkisofsOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) ;
MRESULT EXPENTRY fileNameOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) ;
MRESULT EXPENTRY cdTypeOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY authorOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) ;

/********************************************************/
/*                                                      */
/* This procedure handles the imagename frame extension */
/*                                                      */
/********************************************************/ 
MRESULT EXPENTRY imageNameDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) 
{
  CWDataFolder* thisPtr;
  FILEDLG fd = { 0 };  
  POINTL ptl;
  SHORT a,b;
  HWND hwndTemp;
  char text[CCHMAXPATH];

  switch(msg)
    {
    case WM_INITDLG:
      WinSetWindowULong(hwnd,QWL_USER,(ULONG)PVOIDFROMMP(mp2));//Save object ptr.	
      WinSendMsg(WinWindowFromID(hwnd,IDEF_IMAGENAME),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)CCHMAXPATH),0);
      WinSetWindowText(WinWindowFromID(hwnd,IDEF_IMAGENAME),chrImage);
      return (MRESULT) TRUE;
    case WM_HELP:
      thisPtr=(CWDataFolder*) WinQueryWindowULong(hwnd,QWL_USER);
      if(!thisPtr)
        break;
      switch(WinQueryWindowUShort(WinQueryFocus(HWND_DESKTOP),QWS_ID))
        {
        case IDEF_IMAGENAME:
          return (MRESULT)thisPtr->wpDisplayHelp(IDEF_IMAGENAME,AFHELPLIBRARY);
        case IDPB_IMAGEBROWSE:
          return (MRESULT)thisPtr->wpDisplayHelp(IDPB_IMAGEBROWSE,AFHELPLIBRARY);
        default:
          break;
        }
      break;
    case WM_BUTTON2DOWN:
      /* Display popup menu for image name frame extension */
      WinQueryPointerPos(HWND_DESKTOP,&ptl);
      WinMapWindowPoints(HWND_DESKTOP,hwnd,&ptl,1);
      hwndTemp=WinWindowFromPoint(hwnd,&ptl,FALSE);/* Get child window under ptr */
      switch(WinQueryWindowUShort(hwndTemp,QWS_ID))/* Get child window id */
        {
        case IDEF_IMAGENAME:
          a=IDM_IMAGENAME;
          b=a;
          break;
        case IDPB_IMAGEBROWSE:
          a=IDM_IMAGEBROWSE;
          b=a;
          break;
         default:
          a=IDM_DATADEFAULT;
          b=a;
          break;
        }
      hwndTemp=WinLoadMenu(hwnd,hDataResource,a);
      if(hwndTemp) {
        if(WinPopupMenu(hwnd,hwnd,hwndTemp,ptl.x,ptl.y,b,PU_VCONSTRAIN|PU_HCONSTRAIN|
                        PU_MOUSEBUTTON1|PU_KEYBOARD|PU_NONE|PU_SELECTITEM)) {
          return (MRESULT)FALSE;
        }
      }
      break;
    case WM_DESTROY:
      /* The notebook closes and gets destroyed */
      /* Let the WPS save the new instance data */
      /*  thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_FILENAMEUNDO),QWL_USER);
          if(thisPtr) {
          thisPtr->wpSaveDeferred();
          }*/
      WinQueryWindowText( WinWindowFromID(hwnd,IDEF_IMAGENAME),sizeof(chrImage),chrImage);      
      return (MRESULT) TRUE;
      /*   case WM_CONTROL:
      switch(SHORT1FROMMP(mp1))
        {
        case IDEF_IMAGENAME:
          DosBeep(100,1000);
          break;
        default:
          break;
        }
      return MRESULT(FALSE);*/
    case WM_COMMAND:
      thisPtr=(CWDataFolder*) WinQueryWindowULong(hwnd,QWL_USER);
      if(!thisPtr)
        break;	
      switch(SHORT1FROMMP(mp1))
        {
        case IDPB_IMAGEBROWSE:
          /* User pressed the BROWSE button */
          fd.cbSize = sizeof( fd );
          /* It's an centered 'Save'-dialog */
          fd.fl = FDS_OPEN_DIALOG|FDS_CENTER;
          /* Set the title of the file dialog */
          /* Text: "Path for ISO-Image file" */
          getMessage(text, IDSTRD_IMAGENAMEBROWSE,sizeof(text), hDataResource, hwnd);
          fd.pszTitle = text;
          /* Only show *.exe files */
          sprintf(fd.szFullFile,"%s","*.raw");
          
          if( WinFileDlg( HWND_DESKTOP, hwnd, &fd ) == NULLHANDLE )
            {
              /* WinFileDlg failed */
              break;
            }
          if( fd.lReturn == DID_OK )
            {
              WinSetWindowText( WinWindowFromID(hwnd,IDEF_IMAGENAME), fd.szFullFile );
              sprintf(chrImage,"%s",fd.szFullFile);
            }
          break;
          
          /* Popup menu commands: */
        case IDM_IMAGENAME:
          return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_IMAGENAME,AFHELPLIBRARY);
        case IDM_IMAGEBROWSE:
          return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_IMAGEBROWSE,AFHELPLIBRARY);
        case IDM_DATADEFAULT:
          return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_DATADEFAULT,AFHELPLIBRARY);
        default:
          break;
        }
      return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}


/********************************************************/ 
/*                                                      */
/*  This procedure handles the main frame extension     */ 
/*                                                      */
/********************************************************/ 
MRESULT EXPENTRY mkisofsMainDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) 
{
  CWDataFolder* thisPtr;
  ULONG ulFlags;
  struct stat buf;
  char text[CCHMAXPATH];
  char title[CCHMAXPATH];
  char text2[CCHMAXPATH];
  POINTL ptl;
  SHORT a,b;
  HWND hwndTemp;
  static HWND hwndStatus;
  ULONG rc;

  switch(msg)
    {
    case WM_INITDLG:
      WinSetWindowULong(hwnd,QWL_USER,(ULONG)PVOIDFROMMP(mp2));//Save object ptr.	
      WinCheckButton(hwnd,IDCB_DUMMY,((CWDataFolder*)(PVOIDFROMMP(mp2)))->sDummy);
      ulFlags=((CWDataFolder*)PVOIDFROMMP(mp2))->cwQueryCreateFlags();
      thisPtr=(CWDataFolder*)PVOIDFROMMP(mp2);
      if(ulFlags&IDCR_IMAGEONLY) {
        WinCheckButton(hwnd,IDRB_IMAGEONLY,1);
        WinShowWindow(WinWindowFromID(hwnd,IDPB_WRITECD),FALSE);
        WinShowWindow(WinWindowFromID(hwnd,IDCB_DUMMY),FALSE);
        WinShowWindow(WinWindowFromID(hwnd,IDPB_CREATE),TRUE);
        thisPtr->cwShowImageName(TRUE);
      }
      else {
        WinShowWindow(WinWindowFromID(hwnd,IDPB_CREATE),FALSE);
        WinShowWindow(WinWindowFromID(hwnd,IDPB_WRITECD),TRUE);
        WinShowWindow(WinWindowFromID(hwnd,IDCB_DUMMY),TRUE);
      }
      if(ulFlags&IDCR_WRITEIMAGE) { 
        WinCheckButton(hwnd,IDRB_WRITEIMAGE,1);
        thisPtr->cwShowImageName(TRUE);
      }
      if(ulFlags&IDCR_ONTHEFLY) {
        thisPtr->cwShowImageName(FALSE);
        WinCheckButton(hwnd,IDRB_ONTHEFLY,1);
      }
      return (MRESULT) TRUE;
    case WM_HELP:
      thisPtr=(CWDataFolder*) WinQueryWindowULong(hwnd,QWL_USER);
      if(!thisPtr)
        break;
      switch(WinQueryWindowUShort(WinQueryFocus(HWND_DESKTOP),QWS_ID))
        {
        case IDRB_IMAGEONLY:
          return (MRESULT)thisPtr->wpDisplayHelp(IDRB_IMAGEONLY,AFHELPLIBRARY);
        case IDRB_WRITEIMAGE:
          return (MRESULT)thisPtr->wpDisplayHelp(IDRB_WRITEIMAGE,AFHELPLIBRARY);
        case IDRB_ONTHEFLY:
          return (MRESULT)thisPtr->wpDisplayHelp(IDRB_ONTHEFLY,AFHELPLIBRARY);
        case IDPB_MKISOFSSETTINGS:
          return (MRESULT)thisPtr->wpDisplayHelp(IDPB_MKISOFSSETTINGS,AFHELPLIBRARY);
        case IDPB_CHECKSIZE:
          return (MRESULT)thisPtr->wpDisplayHelp(IDPB_CHECKSIZE,AFHELPLIBRARY);
        case IDPB_WRITECD:
          return (MRESULT)thisPtr->wpDisplayHelp(IDPB_WRITECD,AFHELPLIBRARY);
        case IDPB_CREATE:
          return (MRESULT)thisPtr->wpDisplayHelp(IDPB_CREATE,AFHELPLIBRARY);
        case IDCB_DUMMY:
          return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_MKISOFSDUMMY,AFHELPLIBRARY);
        default:
          break;
        }
      break;
    case WM_BUTTON2DOWN:
      /* Display popup menu for control the mouse is over */
      WinQueryPointerPos(HWND_DESKTOP,&ptl);
      WinMapWindowPoints(HWND_DESKTOP,hwnd,&ptl,1);
      hwndTemp=WinWindowFromPoint(hwnd,&ptl,FALSE);/* Get child window under ptr */
      switch(WinQueryWindowUShort(hwndTemp,QWS_ID))/* Get child window id */
        {
        case IDRB_IMAGEONLY:
          a=IDM_IMAGEONLY;
          b=a;
          break;
        case IDRB_WRITEIMAGE:
          a=IDM_WRITEIMAGE;
          b=a;
          break;
        case IDRB_ONTHEFLY:
          a=IDM_ONTHEFLY;
          b=a;
          break;
        case IDPB_CHECKSIZE:
          a=IDM_CHECKSIZE;
          b=a;
          break;
          /*   case IDPB_WRITECD:
               a=IDM_WRITECD;
               b=a;
               break;
               case IDPB_CREATE:
               a=IDM_CREATE;
               b=a;
               break;*/
        case IDPB_MKISOFSSETTINGS:
          a=IDM_MKISOFSSETTINGS;
          b=a;
          break;
        case IDCB_DUMMY:
          a=IDM_MKISOFSDUMMY;
          b=a;
          break;
        default:
          a=IDM_DATADEFAULT;
          b=a;
          break;
        }
      hwndTemp=WinLoadMenu(hwnd,hDataResource,a);
      if(hwndTemp) {
        if(WinPopupMenu(hwnd,hwnd,hwndTemp,ptl.x,ptl.y,b,PU_VCONSTRAIN|PU_HCONSTRAIN|
                        PU_MOUSEBUTTON1|PU_KEYBOARD|PU_NONE|PU_SELECTITEM)) {
          return (MRESULT)FALSE;
        }
      }
      break;
    case WM_DESTROY:
      /* The folderwindow closes and gets destroyed */
      thisPtr=(CWDataFolder*) WinQueryWindowULong(hwnd,QWL_USER);
      if(thisPtr) {
        thisPtr->sDummy=WinQueryButtonCheckstate(hwnd,IDCB_DUMMY);
        ulFlags=0;
        if(WinQueryButtonCheckstate(hwnd,IDRB_IMAGEONLY)&1)
          ulFlags|=IDCR_IMAGEONLY;
        if(WinQueryButtonCheckstate(hwnd,IDRB_WRITEIMAGE)&1)
          ulFlags|=IDCR_WRITEIMAGE;
        if(WinQueryButtonCheckstate(hwnd,IDRB_ONTHEFLY)&1)
          ulFlags|=IDCR_ONTHEFLY;
        thisPtr->cwSetCreateFlags( ulFlags,0xF);
      }
      return (MRESULT) TRUE;
    case WM_CONTROL:
      thisPtr=(CWDataFolder*) WinQueryWindowULong(hwnd,QWL_USER);
      if(!thisPtr) return (MRESULT) TRUE;
      switch(SHORT1FROMMP(mp1))
        {
        case IDCB_DUMMY:
          thisPtr->sDummy=WinQueryButtonCheckstate(hwnd,IDCB_DUMMY);
          break;
        case IDRB_WRITEIMAGE:
        case IDRB_IMAGEONLY:
        case IDRB_ONTHEFLY:
          ulFlags=0;
          if(WinQueryButtonCheckstate(hwnd,IDRB_IMAGEONLY)&1) {
            ulFlags|=IDCR_IMAGEONLY;
            WinShowWindow(WinWindowFromID(hwnd,IDPB_WRITECD),FALSE);
            WinShowWindow(WinWindowFromID(hwnd,IDCB_DUMMY),FALSE);
            WinShowWindow(WinWindowFromID(hwnd,IDPB_CREATE),TRUE);
            thisPtr->cwShowImageName(TRUE);
          }
          else {
            if(WinQueryButtonCheckstate(hwnd,IDRB_WRITEIMAGE)&1) {
              ulFlags|=IDCR_WRITEIMAGE;
              thisPtr->cwShowImageName(TRUE);
            }
            if(WinQueryButtonCheckstate(hwnd,IDRB_ONTHEFLY)&1) {
              ulFlags|=IDCR_ONTHEFLY;
              thisPtr->cwShowImageName(FALSE);
            }
            WinShowWindow(WinWindowFromID(hwnd,IDPB_CREATE),FALSE);
            WinShowWindow(WinWindowFromID(hwnd,IDPB_WRITECD),TRUE);
            WinShowWindow(WinWindowFromID(hwnd,IDCB_DUMMY),TRUE);
          }
          thisPtr->cwSetCreateFlags( ulFlags,0xF);
          break;
        default:
          break;
        }
      return (MRESULT) TRUE;
    case WM_APPTERMINATENOTIFY:
      if(WinIsWindow(WinQueryAnchorBlock(HWND_DESKTOP),hwndStatus)) {
        WinDestroyWindow(hwndStatus);
        hwndStatus=0;
      }
      if(mp1==mp2) {
        /* Text:   "Can't get multisession info from cdrecord/2!"
           Title:  "Get multisession info error"
           */
        messageBox( text, IDSTRD_GETMSINFOERRORTEXT , sizeof(text),
                    title, IDSTRD_GETMSINFOERRORTITLE, sizeof(title),
                    hDataResource, hwnd, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
        /*  WinSendMsg(WinWindowFromID(hwnd,IDSB_PREVIOUSSTART),SPBM_SETCURRENTVALUE,mp1,0L);
        WinSendMsg(WinWindowFromID(hwnd,IDSB_NEXTSTART),SPBM_SETCURRENTVALUE,mp2,0L);*/
        break;
      }
      // else {
      /* Update spin buttons */
      /*  WinSendMsg(WinWindowFromID(hwnd,IDSB_PREVIOUSSTART),SPBM_SETCURRENTVALUE,mp1,0L);
          WinSendMsg(WinWindowFromID(hwnd,IDSB_NEXTSTART),SPBM_SETCURRENTVALUE,mp2,0L);
          }*/
      thisPtr=(CWDataFolder*) WinQueryWindowULong(hwnd,QWL_USER);
      if(thisPtr) {
        thisPtr->cwSetPreviousStartSector(LONGFROMMP(mp1));
        thisPtr->cwSetNextStartSector(LONGFROMMP(mp2));        
        if(thisPtr->bCreate)
          thisPtr->cwCreateImage();
        else
          thisPtr->cwGetImageSize();
      }
      break;
    case WM_COMMAND:	
      thisPtr=(CWDataFolder*) WinQueryWindowULong(hwnd,QWL_USER);
      if(thisPtr) {
        switch(SHORT1FROMMP(mp1))
          {
          case IDPB_CREATE:
            /* User pressed the CREATE button */
            ulFlags=thisPtr->cwQueryCDTypeFlags();
            if((ulFlags & IDCDT_MULTISESSION) && !(ulFlags & IDCDT_FIRSTSESSION)) {
              /* We are building the second image of a multisession disk */
              /* Get the sector information */
              if(hwndStatus)break;
              /* Text:   "Please insert the CD with the previous session into the CD-writer."
                 Title:  "Get multisession info"
                 */
              rc=messageBox( text, IDSTRD_GETMSINFOTEXT , sizeof(text),
                             title, IDSTRD_GETMSINFOTITLE, sizeof(title),
                             hDataResource, hwnd, MB_OKCANCEL | MB_ICONEXCLAMATION|MB_MOVEABLE);          
              if(MBID_OK==rc) {
                /* Get msinfo */
                thisPtr->bCreate=TRUE;
                hwndStatus=WinLoadDlg(HWND_DESKTOP,hwnd,
                                      msInfoStatusDialogProc,hDataResource,IDDLG_GETMSINFOSTATUS,0);
                launchMsInfo(hwnd);
              }
              break;
            }/* if((ulFlags & IDCDT_MULTISESSION) && !(ulFlags & IDCDT_FIRSTSESSION)) */
            thisPtr->cwCreateImage();
            break;
          case IDPB_WRITECD:
            /* User pressed the WRITE button */
            if(WinQueryButtonCheckstate(hwnd,IDRB_WRITEIMAGE)&1)
              thisPtr->cwWriteImage();
            else
              thisPtr->cwWriteOnTheFly();
            break;
          case IDPB_MKISOFSSETTINGS:
            /* User pressed the SETTINGS... button */
            thisPtr->wpViewObject(NULLHANDLE,OPEN_SETTINGS,0);
            break;
          case IDPB_CHECKSIZE:
            if(WinQueryButtonCheckstate(hwnd,IDRB_WRITEIMAGE)&1) {
              /* Get current filename from entryfield */
              WinQueryWindowText( WinWindowFromID(thisPtr->hwndImageName,IDEF_IMAGENAME),sizeof(chrImage),chrImage);
              /* Check if we have an output filename */
              if(strlen(chrImage)<=3) {
                /* Text: "You have to specify a valid filename including the path."
                   Title: "Write image, check size"
                   */
                messageBox( text, IDSTRD_CHECKSIZEERRORFILENAME , sizeof(text),
                            title, IDSTRD_CHECKSIZEERRORTITLE, sizeof(title),
                            hDataResource, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
                break;
              }
              /* Check if we have a full path (just a quick check) */
              if(chrImage[1]!=':') {
                /* Text: "You have to specify a full path."
                   Title: "Write image, check size"
                   */
                messageBox( text, IDSTRD_CHECKSIZEERRORFULLPATH , sizeof(text),
                            title, IDSTRD_CHECKSIZEERRORTITLE, sizeof(title),
                            hDataResource, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
                break;
              }/* if(chrImage[1]!=':') */
              if(stat(chrImage,&buf))
                /* Text: "Sorry, file size unknown."
                   Title: "Write image, check size"
                   */
                messageBox( text, IDSTRD_CHECKSIZEERRORNOSIZE , sizeof(text),
                            title, IDSTRD_CHECKSIZEERRORTITLE, sizeof(title),
                            hDataResource, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
              else {
                /* Title: "Imagesize is %d.%0.3d.%0.3d bytes" */
                getMessage(text2, IDSTRD_IMAGESIZE, sizeof(text2), hDataResource,HWND_DESKTOP);
                sprintf(text,text2,
                        buf.st_size/1000000,(buf.st_size%1000000)/1000,buf.st_size%1000);
                thisPtr->cwSetStatusText(text);
                DosBeep(2000,200);
              }
            }/* if(WinQueryButtonCheckstate(hwnd,IDRB_WRITEIMAGE)&1) */
            else {/* if(WinQueryButtonCheckstate(hwnd,IDRB_WRITEIMAGE)&1)*/
              ulFlags=thisPtr->cwQueryCDTypeFlags();
              if((ulFlags & IDCDT_MULTISESSION) && !(ulFlags & IDCDT_FIRSTSESSION)) {
                /* We are building the second image of a multisession disk */
                /* Get the sector information */
                if(hwndStatus)break;
                /* Text:   "Please insert the CD with the previous session into the CD-writer."
                   Title:  "Get multisession info"
                   */
                rc=messageBox( text, IDSTRD_GETMSINFOTEXT , sizeof(text),
                               title, IDSTRD_GETMSINFOTITLE, sizeof(title),
                               hDataResource, hwnd, MB_OKCANCEL | MB_ICONEXCLAMATION|MB_MOVEABLE);          
                if(MBID_OK==rc) {
                  /* Get msinfo */
                  thisPtr->bCreate=FALSE;
                  hwndStatus=WinLoadDlg(HWND_DESKTOP,hwnd,
                                        msInfoStatusDialogProc,hDataResource,IDDLG_GETMSINFOSTATUS,0);
                  launchMsInfo(hwnd);
                  //thisPtr->cwGetImageSize();
                }/* if(MBID_OK==rc) */
              }/* if((ulFlags & IDCDT_MULTISESSION) && !(ulFlags & IDCDT_FIRSTSESSION)) */
              else 
                thisPtr->cwGetImageSize();
            }
            break;
            /* Popup menue commands */
          case IDM_IMAGEONLY:
            return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_IMAGEONLY,AFHELPLIBRARY);
          case IDM_WRITEIMAGE:
            return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_WRITEIMAGE,AFHELPLIBRARY);
          case IDM_ONTHEFLY:
            return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_ONTHEFLY,AFHELPLIBRARY);
          case IDM_CHECKSIZE:
            return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_CHECKSIZE,AFHELPLIBRARY);
          case IDM_WRITECD:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_WRITECD,AFHELPLIBRARY);
          case IDM_CREATE:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_CREATE,AFHELPLIBRARY);
          case IDM_MKISOFSSETTINGS:
            return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_CDSETTINGS,AFHELPLIBRARY);
          case IDM_MKISOFSDUMMY:
            return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_DUMMY,AFHELPLIBRARY);    
          case IDM_DATADEFAULT:
            return (MRESULT)thisPtr->wpDisplayHelp(IDHLP_DATADEFAULT,AFHELPLIBRARY);
          default:
            break;
          }
      }
      return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}


MRESULT EXPENTRY msInfoStatusDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) 
{
  
  switch(msg)
    {
    case WM_INITDLG :   
      WinShowWindow(WinWindowFromID(hwnd,IDPB_STATUSOK),FALSE);
      return (MRESULT) TRUE;
    case WM_COMMAND:
      switch(SHORT1FROMMP(mp1))
        {
        case IDPB_ABORTWRITE:
          /* User pressed the ABORT button */
          DosBeep(1000,200);
          WinEnableWindow(WinWindowFromID(hwnd,IDPB_ABORTWRITE),FALSE);          
          WinPostMsg(WinQueryWindow(hwnd,QW_OWNER),WM_APPTERMINATENOTIFY,MPFROMLONG(ACKEY_ABORT),0);
          break;
        case IDPB_STATUSOK:
          WinPostMsg(WinQueryWindow(hwnd,QW_OWNER),WM_CLOSE,0,0);
          break;
        default:
          break;
        }
      return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);    
}

MRESULT EXPENTRY dataCDStatusLineDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) 
{
  CWAudioFolder *thisPtr;
  HWND hwndMenu;
  POINTL ptl;
  SHORT a,b;
    
  switch(msg)
    {
    case WM_INITDLG :   
      WinSetWindowULong(hwnd,QWL_USER,(ULONG)PVOIDFROMMP(mp2));//Save object ptr.
      return (MRESULT) TRUE;
    case WM_HELP:
      break;
    case WM_DESTROY:
      /* The dialog closes and gets destroyed */     
      break;	
      //  case WM_BUTTON2DOWN:
      /* Display popup menu for status bar */
      //  WinQueryPointerPos(HWND_DESKTOP,&ptl);
      //WinMapWindowPoints(HWND_DESKTOP,hwnd,&ptl,1);
      //hwndMenu=WinWindowFromPoint(hwnd,&ptl,FALSE);/* Get child window under ptr */
      //switch(WinQueryWindowUShort(hwndMenu,QWS_ID))/* Get child window id */
      //  {
      //  default:
      //    a=IDM_STATUSDEFAULTHELP;
      //    b=a;
      //    break;
      /*  }
      hwndMenu=WinLoadMenu(hwnd,queryModuleHandle(),a);
      if(hwndMenu) {
        if(WinPopupMenu(hwnd,hwnd,hwndMenu,ptl.x,ptl.y,b,PU_VCONSTRAIN|PU_HCONSTRAIN|
                        PU_MOUSEBUTTON1|PU_KEYBOARD|PU_NONE|PU_SELECTITEM)) {
										
          return (MRESULT)FALSE;
        }
      }
      break;*/
     case WM_COMMAND:	
      thisPtr=(CWAudioFolder*) WinQueryWindowULong(hwnd,QWL_USER);
      if(thisPtr){
        switch(SHORT1FROMMP(mp1))
          {
          case IDM_STATUSDEFAULTHELP:
            //       return (MRESULT)thisPtr->wpDisplayHelp(603,AFHELPLIBRARY);
          default:
            break;
          }
      }/* end of if(thisPtr) */
			
      return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

/************************************************************************/

//   Settings-Pages

/************************************************************************/

/***********************************************************************/
/*                                                                     */
/* This procedure handles the general settings page for creator folders*/
/*                                                                     */
/***********************************************************************/
MRESULT EXPENTRY dataGeneralOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) 
{
  FILEDLG fd = { 0 };
  CWDataFolder* thisPtr;
  ULONG ulFlags;
  int a;
  char chrCD[4];
  char driveID[40];
  char text[CCHMAXPATH];

  HOBJECT  hObject;

  switch(msg)
    {
    case WM_INITDLG :   
      WinSetWindowULong(WinWindowFromID(hwnd,IDPB_SCAN),
                        QWL_USER,(ULONG)PVOIDFROMMP(mp2));//Save object ptr.
      WinSetWindowText(WinWindowFromID(hwnd,IDDD_DEVICESELECTION),chrDeviceName);
      /* Speed spin button */
      WinSendMsg(WinWindowFromID(hwnd,IDSB_SPEED),SPBM_SETLIMITS,MPFROMLONG(16),MPFROMLONG(1));
      WinSendMsg(WinWindowFromID(hwnd,IDSB_SPEED),SPBM_SETCURRENTVALUE,(MPARAM)iSpeed,MPFROMLONG(0));
      /* FIFO spin button */
      WinSendMsg(WinWindowFromID(hwnd,IDSB_FIFO),SPBM_SETLIMITS,MPFROMLONG(64),MPFROMLONG(4));
      WinSendMsg(WinWindowFromID(hwnd,IDSB_FIFO),SPBM_SETCURRENTVALUE,(MPARAM)iFifo,MPFROMLONG(0));

      if(lCDROptions&IDCDR_HIDEWINDOW)
        WinCheckButton(hwnd,IDCB_CDRSTARTHIDDEN,1);
      if(lCDROptions&IDCDR_CLOSEWINDOW)
        WinCheckButton(hwnd,IDCB_CDRCLOSEWINDOW,1);

      return (MRESULT) TRUE;
    case WM_HELP:
      break;
    case WM_APPTERMINATENOTIFY:
      switch(LONGFROMMP(mp1)) {
      case ACKEY_SCANBUS:
        break;
      default:
        break;
      }/* switch */
      break; 
    case WM_DESTROY:
      /* The notebook closes and gets destroyed */
      WinQueryWindowText( WinWindowFromID(hwnd,IDDD_DEVICESELECTION),sizeof(chrDeviceName),chrDeviceName);
      sscanf(chrDeviceName,"%d,%d,%d ",&iBus,&iTarget,&iLun);
      WinSendMsg(WinWindowFromID(hwnd,IDSB_SPEED),SPBM_QUERYVALUE,MPFROMP(&ulFlags),
                 MPFROM2SHORT(0,SPBQ_ALWAYSUPDATE));
      iSpeed=(int)ulFlags;
      
      WinSendMsg(WinWindowFromID(hwnd,IDSB_FIFO),SPBM_QUERYVALUE,MPFROMP(&ulFlags),
                 MPFROM2SHORT(0,SPBQ_ALWAYSUPDATE));
      iFifo=(int)ulFlags;
      
      ulFlags=0;
      if(WinQueryButtonCheckstate(hwnd,IDCB_CDRSTARTHIDDEN)&1)
        ulFlags|=IDCDR_HIDEWINDOW;
      if(WinQueryButtonCheckstate(hwnd,IDCB_CDRCLOSEWINDOW)&1)
        ulFlags|=IDCDR_CLOSEWINDOW;
      lCDROptions=ulFlags;
      /* Let the WPS save the new data */
      thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_SCAN),QWL_USER);
      if(thisPtr)
        thisPtr->wpSaveImmediate();      
      /* Setup is done */
      return (MRESULT) TRUE;
    case WM_COMMAND:    
      switch(SHORT1FROMMP(mp1))
        {
        case IDPB_WIDERRUFEN:
          /* User pressed the UNDO button */
          WinSendMsg(WinWindowFromID(hwnd,IDSB_SPEED),SPBM_SETCURRENTVALUE,MPFROMLONG((LONG)iSpeed),MPFROMLONG(0));
          WinSendMsg(WinWindowFromID(hwnd,IDSB_FIFO),SPBM_SETCURRENTVALUE,MPFROMLONG((LONG)iFifo),MPFROMLONG(0));
          if(lCDROptions&IDCDR_HIDEWINDOW)
            WinCheckButton(hwnd,IDCB_CDRSTARTHIDDEN,1);
          if(lCDROptions&IDCDR_CLOSEWINDOW)
            WinCheckButton(hwnd,IDCB_CDRCLOSEWINDOW,1);
          WinSetWindowText(WinWindowFromID(hwnd,IDDD_DEVICESELECTION),chrDeviceName);
          break;
        case IDPB_SCAN:
          _beginthread(scanbusThreadFunc,NULL,8192,(void*)hwnd);
          break;
        default:
          break;
        }
      return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}


/* This procedure handles the mkisofs settings page */ 
MRESULT EXPENTRY mkisofsOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) 
{
  FILEDLG fd = { 0 };
  CWDataFolder* thisPtr;
  ULONG ulFlags;
  char text[CCHMAXPATH];

  switch(msg)
    {
    case WM_INITDLG :	
      WinSetWindowULong(WinWindowFromID(hwnd,IDPB_MKISOFSBROWSE),
			QWL_USER,(ULONG)PVOIDFROMMP(mp2));//Save object ptr.
      WinSendMsg(WinWindowFromID(hwnd,IDEF_MKISOFSPATH),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)CCHMAXPATH),0);
      WinSetWindowText(WinWindowFromID(hwnd,IDEF_MKISOFSPATH),chrMkisofs);
      WinSendMsg(WinWindowFromID(hwnd,IDEF_MKISOFSOPTIONS),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)CCHMAXPATH),0);
      WinSetWindowText(WinWindowFromID(hwnd,IDEF_MKISOFSOPTIONS),chrMkisofsOptions);
      /*  if(((CWDataFolder*)PVOIDFROMMP(mp2))->cwQueryMkisofsFlags()&IDMK_LOGFILE)
          WinCheckButton(hwnd,IDCB_LOGFILE,1);
          if(lMKOptions&IDMK_HIDEWINDOW)
          WinCheckButton(hwnd,IDCB_MKISTARTHIDDEN,1);
          if(lMKOptions&IDMK_CLOSEWINDOW)
          WinCheckButton(hwnd,IDCB_MKICLOSEWINDOW,1);*/
      return (MRESULT) TRUE;
      /*    case WM_HELP:
			thisPtr=(CWAudioFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_CDRECORDBROWSE),QWL_USER);
			if(!thisPtr)
            break;
			switch(WinQueryWindowUShort(WinQueryFocus(HWND_DESKTOP),QWS_ID))
            {
            case IDEF_CDRECORDOPTIONS:
            return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDOPTIONS,AFHELPLIBRARY);
            case IDPB_WIDERRUFEN:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_WIDERRUFEN,AFHELPLIBRARY);
            case IDPB_CDRECORDBROWSE:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_CDRECORDBROWSE,AFHELPLIBRARY);
            case IDEF_CDRECORDPATH:
            return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDPATH,AFHELPLIBRARY);
            default:
            break;
            }
			return (MRESULT)thisPtr->wpDisplayHelp(IDDLG_CDRECORDSETUP,AFHELPLIBRARY);
			break;*/
		case WM_DESTROY:
      /* The notebook closes and gets destroyed */
      /* Query the cdrecord path from the entryfield */     
      WinQueryWindowText( WinWindowFromID(hwnd,IDEF_MKISOFSPATH),sizeof(chrMkisofs),chrMkisofs);
      /* Query the cdrecord options from the entryfield */     
      WinQueryWindowText( WinWindowFromID(hwnd,IDEF_MKISOFSOPTIONS),sizeof(chrMkisofsOptions),chrMkisofsOptions);
      ulFlags=0;
      /*   if(WinQueryButtonCheckstate(hwnd,IDCB_MKISTARTHIDDEN)&1)
           ulFlags|=IDMK_HIDEWINDOW;
           if(WinQueryButtonCheckstate(hwnd,IDCB_MKICLOSEWINDOW)&1)
           ulFlags|=IDMK_CLOSEWINDOW;*/
      lMKOptions=ulFlags;
      /* Let the WPS save the new instance data */
      thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_MKISOFSBROWSE),QWL_USER);
      if(thisPtr) {
        /*if(WinQueryButtonCheckstate(hwnd,IDCB_LOGFILE)&1)
           thisPtr->cwSetMkisofsFlags(IDMK_LOGFILE,IDMK_LOGFILE);
           else
           thisPtr->cwSetMkisofsFlags(0,IDMK_LOGFILE); */
        thisPtr->wpSaveDeferred();
      }
      /* Setup is done */
      MkisofsSetupDone=TRUE;
      return (MRESULT) TRUE;
    case WM_COMMAND:	
    switch(SHORT1FROMMP(mp1))
      {
      case IDPB_MKISOFSBROWSE:
	/* User pressed the browse button */
	fd.cbSize = sizeof( fd );
	/* It's an centered 'Open'-dialog */
	fd.fl = FDS_OPEN_DIALOG|FDS_CENTER;
	/* Set the title of the file dialog */
    /* Text: "Search mkisofs" */
    getMessage(text,IDSTRD_FDLGSEARCHMKISOFS, sizeof(text), hDataResource,hwnd);
	fd.pszTitle = text;
	/* Only show *.exe files */
	sprintf(fd.szFullFile,"%s","*.exe");

	if( WinFileDlg( HWND_DESKTOP, hwnd, &fd ) == NULLHANDLE )
	  {
	    /* WinFileDlg failed */
	    break;
	  }
	if( fd.lReturn == DID_OK )
	  {
	    WinSetWindowText( WinWindowFromID(hwnd,IDEF_MKISOFSPATH), fd.szFullFile );
	  }
	break;
      case IDPB_MKISOFSUNDO:
	/* User pressed the UNDO button */

 	WinSetWindowText(WinWindowFromID(hwnd,IDEF_MKISOFSPATH),chrMkisofs);
	WinSetWindowText(WinWindowFromID(hwnd,IDEF_MKISOFSOPTIONS),chrMkisofsOptions);
    /*    if(lMKOptions&IDMK_HIDEWINDOW)
          WinCheckButton(hwnd,IDCB_MKISTARTHIDDEN,1);
          if(lMKOptions&IDMK_CLOSEWINDOW)
          WinCheckButton(hwnd,IDCB_MKICLOSEWINDOW,1); 
          thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_MKISOFSBROWSE),QWL_USER);
          if(thisPtr) {
          if(thisPtr->cwQueryMkisofsFlags()&IDMK_LOGFILE)
          WinCheckButton(hwnd,IDCB_LOGFILE,1);
          else
          WinCheckButton(hwnd,IDCB_LOGFILE,0);
          } */
	break;
      default:
	break;
      }
      return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}


/* This procedure handles the cdrecord settings page for data folders 
 * The only difference to the audio folder is the option entryfield.
 * It is possible to specify different options for data and audio
 * since version 0.34 */ 
MRESULT EXPENTRY cdrecordOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) 
{
  FILEDLG fd = { 0 };
  CWAudioFolder* thisPtr;
  ULONG ulFlags;
  int a;
  char chrCD[4];
  char driveID[40];
  char text[CCHMAXPATH];

  HOBJECT  hObject;

  switch(msg)
    {
    case WM_INITDLG :   
      WinSetWindowULong(WinWindowFromID(hwnd,IDPB_CDRECORDBROWSE),
                        QWL_USER,(ULONG)PVOIDFROMMP(mp2));//Save object ptr.
      WinSendMsg(WinWindowFromID(hwnd,IDEF_CDRECORDPATH),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)CCHMAXPATH),0);
      WinSetWindowText(WinWindowFromID(hwnd,IDEF_CDRECORDPATH),chrCDRecord);
      WinSendMsg(WinWindowFromID(hwnd,IDEF_CDRECORDOPTIONS),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)CCHMAXPATH),0);
      WinSetWindowText(WinWindowFromID(hwnd,IDEF_CDRECORDOPTIONS),chrDataCDROptions);
      for( a=0; a<iNumCD ;a++) {
        chrCD[0]=cFirstCD+a;
        chrCD[1]=':';
        chrCD[2]=0;
        WinSendMsg(WinWindowFromID(hwnd,IDLB_WRITERLETTER),LM_INSERTITEM,MPFROMSHORT(LIT_END),(MPARAM)chrCD);
        if(!a){
          if(!setupDone)
            WinSetWindowText(WinWindowFromID(hwnd,IDLB_WRITERLETTER),chrCD);
          else
            WinSetWindowText(WinWindowFromID(hwnd,IDLB_WRITERLETTER),chosenWriter);
        }
      }
      return (MRESULT) TRUE;
    case WM_HELP:
      thisPtr=(CWAudioFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_CDRECORDBROWSE),QWL_USER);
      if(!thisPtr)
        break;
      switch(WinQueryWindowUShort(WinQueryFocus(HWND_DESKTOP),QWS_ID))
        {
        case IDEF_CDRECORDOPTIONS:
          return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDOPTIONS,AFHELPLIBRARY);
        case IDPB_WIDERRUFEN:
          return (MRESULT)thisPtr->wpDisplayHelp(IDPB_WIDERRUFEN,AFHELPLIBRARY);
        case IDPB_CDRECORDBROWSE:
          return (MRESULT)thisPtr->wpDisplayHelp(IDPB_CDRECORDBROWSE,AFHELPLIBRARY);
        case IDEF_CDRECORDPATH:
          return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDPATH,AFHELPLIBRARY);
        default:
          break;
        }
      return (MRESULT)thisPtr->wpDisplayHelp(IDDLG_CDRECORDSETUP,AFHELPLIBRARY);
      break;
    case WM_DESTROY:
      /* The notebook closes and gets destroyed */
      /* Query the cdrecord path from the entryfield */     
      WinQueryWindowText( WinWindowFromID(hwnd,IDEF_CDRECORDPATH),sizeof(chrCDRecord),chrCDRecord);
      /* Query the cdrecord options from the entryfield */     
      WinQueryWindowText( WinWindowFromID(hwnd,IDEF_CDRECORDOPTIONS),sizeof(chrDataCDROptions),chrDataCDROptions);
      // sendConfig();

      /* Set/unset writeflag of diskobject */
      /*      for( a=0; a<iNumCD ;a++) {
              chrCD[0]=cFirstCD+a;
              chrCD[1]=0;*/
      /* Build ID of CD-Drive object */
      //sprintf(driveID,"<WP_DRIVE_%s>",chrCD);
      /* Clear writer flag of disk objects */
      //if((hObject=WinQueryObject(driveID))!=NULL) {
      //  WinSetObjectData(hObject,"ISWRITER=0");
      // }
      //}               
      /* Query the cd-drive */
      WinQueryWindowText( WinWindowFromID(hwnd,IDLB_WRITERLETTER),sizeof(chosenWriter),chosenWriter);
      //    WinQueryWindowText( WinWindowFromID(hwnd,IDLB_WRITERLETTER),sizeof(chrCD),chrCD);
      // chrCD[1]=0;
      /* Build ID of chosenCD-Drive object */
      // sprintf(driveID,"<WP_DRIVE_%s>",chrCD);
      /* Set writer flag of this disk object */
      // if((hObject=WinQueryObject(driveID))!=NULL) {
      //        WinSetObjectData(hObject,"ISWRITER=1");
      //}
      /* Let the WPS save the new data */
      thisPtr=(CWAudioFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_CDRECORDBROWSE),QWL_USER);
      if(thisPtr)
        thisPtr->wpSaveDeferred();      
      /* Setup is done */
      setupDone=TRUE;
      return (MRESULT) TRUE;
    case WM_COMMAND:    
      switch(SHORT1FROMMP(mp1))
        {
        case IDPB_CDRECORDBROWSE:
          /* User pressed the browse button */
          fd.cbSize = sizeof( fd );
          /* It's an centered 'Open'-dialog */
          fd.fl = FDS_OPEN_DIALOG|FDS_CENTER;
          /* Title: "Search CDRecord/2" */
          getMessage(text,IDSTR_FDLGSEARCHCDR2TITLE,sizeof(text), hDataResource,hwnd);
          /* Set the title of the file dialog */
          //fd.pszTitle = "Search CDRecord/2";
          fd.pszTitle = text;
          /* Only show *.exe files */
          sprintf(fd.szFullFile,"%s","*.exe");

          if( WinFileDlg( HWND_DESKTOP, hwnd, &fd ) == NULLHANDLE )
            {
              /* WinFileDlg failed */
              break;
            }
          if( fd.lReturn == DID_OK )
            {
              WinSetWindowText( WinWindowFromID(hwnd,IDEF_CDRECORDPATH), fd.szFullFile );
            }
          break;
        case IDPB_WIDERRUFEN:
          /* User pressed the UNDO button */
          WinSetWindowText(WinWindowFromID(hwnd,IDEF_CDRECORDPATH),chrCDRecord);
          WinSetWindowText(WinWindowFromID(hwnd,IDEF_CDRECORDOPTIONS),chrDataCDROptions);
          break;
        default:
          break;
        }
      return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

/* This procedure handles the filename options page */ 
MRESULT EXPENTRY fileNameOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) 
{
  CWDataFolder* thisPtr;
  ULONG ulFlags;

  switch(msg)
    {
    case WM_INITDLG :	
      WinSetWindowULong(WinWindowFromID(hwnd,IDPB_FILENAMEUNDO),
			QWL_USER,(ULONG)PVOIDFROMMP(mp2));//Save object ptr.
      if(((CWDataFolder*)PVOIDFROMMP(mp2))->cwQueryMkisofsFlags()&IDMK_ALLOW32CHARS)
        WinCheckButton(hwnd,IDCB_ALLOW32CHARS,1);
      if(((CWDataFolder*)PVOIDFROMMP(mp2))->cwQueryMkisofsFlags()&IDMK_LEADINGPERIODS)
        WinCheckButton(hwnd,IDCB_LEADINGPOINTS,1);
      if(((CWDataFolder*)PVOIDFROMMP(mp2))->cwQueryMkisofsFlags()&IDMK_JOLIET)
        WinCheckButton(hwnd,IDCB_JOLIET,1);
      if(((CWDataFolder*)PVOIDFROMMP(mp2))->cwQueryMkisofsFlags()&IDMK_ROCKRIDGE)
        WinCheckButton(hwnd,IDCB_ROCKRIDGE,1);
      if(((CWDataFolder*)PVOIDFROMMP(mp2))->cwQueryMkisofsFlags()&IDMK_TRANSTABLE)
        WinCheckButton(hwnd,IDCB_TRANSTABLE,1);
      if(((CWDataFolder*)PVOIDFROMMP(mp2))->cwQueryMkisofsFlags()&IDMK_ALLFILES)
        WinCheckButton(hwnd,IDCB_ALLFILES,1);
      return (MRESULT) TRUE;
      /*    case WM_HELP:
			thisPtr=(CWAudioFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_CDRECORDBROWSE),QWL_USER);
			if(!thisPtr)
            break;
			switch(WinQueryWindowUShort(WinQueryFocus(HWND_DESKTOP),QWS_ID))
            {
            case IDEF_CDRECORDOPTIONS:
            return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDOPTIONS,AFHELPLIBRARY);
            case IDPB_WIDERRUFEN:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_WIDERRUFEN,AFHELPLIBRARY);
            case IDPB_CDRECORDBROWSE:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_CDRECORDBROWSE,AFHELPLIBRARY);
            case IDEF_CDRECORDPATH:
            return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDPATH,AFHELPLIBRARY);
            default:
            break;
            }
			return (MRESULT)thisPtr->wpDisplayHelp(IDDLG_CDRECORDSETUP,AFHELPLIBRARY);
			break;*/
		case WM_DESTROY:
      /* The notebook closes and gets destroyed */
      /* Let the WPS save the new instance data */
      thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_FILENAMEUNDO),QWL_USER);
      if(thisPtr) {
        ulFlags=0;
        if(WinQueryButtonCheckstate(hwnd,IDCB_ALLOW32CHARS)&1)
          ulFlags|=IDMK_ALLOW32CHARS;
        if(WinQueryButtonCheckstate(hwnd,IDCB_LEADINGPOINTS)&1)
          ulFlags|=IDMK_LEADINGPERIODS;
        if(WinQueryButtonCheckstate(hwnd,IDCB_JOLIET)&1)
          ulFlags|=IDMK_JOLIET;
        if(WinQueryButtonCheckstate(hwnd,IDCB_ROCKRIDGE)&1)
          ulFlags|=IDMK_ROCKRIDGE;
        if(WinQueryButtonCheckstate(hwnd,IDCB_TRANSTABLE)&1)
          ulFlags|=IDMK_TRANSTABLE;
        if(WinQueryButtonCheckstate(hwnd,IDCB_ALLFILES)&1)
          ulFlags|=IDMK_ALLFILES;
        thisPtr->cwSetMkisofsFlags(ulFlags,
                                   IDMK_ALLOW32CHARS|IDMK_LEADINGPERIODS|IDMK_JOLIET|IDMK_ROCKRIDGE|IDMK_TRANSTABLE|IDMK_ALLFILES);
        thisPtr->wpSaveImmediate();
      }
      /* Setup is done */   
      return (MRESULT) TRUE;
    case WM_COMMAND:	
    switch(SHORT1FROMMP(mp1))
      {
      case IDPB_FILENAMEUNDO:
        /* User pressed the UNDO button */
        thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_FILENAMEUNDO),QWL_USER);
        if(thisPtr) {
          ulFlags=thisPtr->cwQueryMkisofsFlags();
          if(ulFlags&IDMK_ALLOW32CHARS)
            WinCheckButton(hwnd,IDCB_ALLOW32CHARS,1);
          else
            WinCheckButton(hwnd,IDCB_ALLOW32CHARS,0);
          if(ulFlags&IDMK_LEADINGPERIODS)
            WinCheckButton(hwnd,IDCB_LEADINGPOINTS,1);
          else
            WinCheckButton(hwnd,IDCB_LEADINGPOINTS,0);
          if(ulFlags&IDMK_JOLIET)
            WinCheckButton(hwnd,IDCB_JOLIET,1);
          else
            WinCheckButton(hwnd,IDCB_JOLIET,0);
          if(ulFlags&IDMK_ROCKRIDGE)
            WinCheckButton(hwnd,IDCB_ROCKRIDGE,1);
          else
            WinCheckButton(hwnd,IDCB_ROCKRIDGE,0);
          if(ulFlags&IDMK_TRANSTABLE)
            WinCheckButton(hwnd,IDCB_TRANSTABLE,1);
          else
            WinCheckButton(hwnd,IDCB_TRANSTABLE,0);
          if(ulFlags&IDMK_ALLFILES)
            WinCheckButton(hwnd,IDCB_ALLFILES,1);
          else
            WinCheckButton(hwnd,IDCB_ALLFILES,0);
        }
        break;
      default:
        break;
      }
    return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}


void showMultiSessionCntrls(HWND hwnd, BOOL bEnable)
{
  /* hwnd:    Dialog-HWND
     bEnable: New enable state */
  BOOL bEnable2;

  /* Control handling seems complicated but it looks smoother
     to the user when doing it this way. */
  if(!bEnable) {
    //WinShowWindow(WinWindowFromID(hwnd,IDST_PREVIOUSINFO),bEnable);
    WinShowWindow(WinWindowFromID(hwnd,IDGB_MERGESESSION),bEnable);//Groupbox
    WinShowWindow(WinWindowFromID(hwnd,IDST_MERGETEXT),bEnable);//Text
    WinShowWindow(WinWindowFromID(hwnd,IDCB_FIXDISK),TRUE);
  }

  bEnable?bEnable2=FALSE:bEnable2=TRUE;
  WinShowWindow(WinWindowFromID(hwnd,IDGB_TRACKTYPE),bEnable2);
  WinShowWindow(WinWindowFromID(hwnd,IDRB_TRACKDATA),bEnable2);
  WinShowWindow(WinWindowFromID(hwnd,IDRB_TRACKMODE2),bEnable2);
  WinShowWindow(WinWindowFromID(hwnd,IDRB_TRACKXA1),bEnable2);
  WinShowWindow(WinWindowFromID(hwnd,IDRB_TRACKXA2),bEnable2);
  WinShowWindow(WinWindowFromID(hwnd,IDRB_TRACKCDI),bEnable2);

  if(bEnable) {
    //  WinShowWindow(WinWindowFromID(hwnd,IDST_PREVIOUSINFO),bEnable);
    WinShowWindow(WinWindowFromID(hwnd,IDGB_MERGESESSION),bEnable);//Groupbox
    WinShowWindow(WinWindowFromID(hwnd,IDST_MERGETEXT),bEnable);//Text
    WinShowWindow(WinWindowFromID(hwnd,IDCB_FIXDISK),FALSE);
  }
}

/*
  This function enables the controls on the CD-type page
  according to the single-/multisession choice.
 */
void enableCDTypeCntrls(HWND hwnd, CWDataFolder* thisPtr)
{
  ULONG ulFlags;

  ulFlags=thisPtr->cwQueryCDTypeFlags();

  if(ulFlags&IDCDT_MULTISESSION) {
    /* Show multisession controls */
    showMultiSessionCntrls(hwnd, TRUE);

    if(ulFlags&IDCDT_MERGESESSION) {
      thisPtr->cwEnableMultiSessionCntrls(hwnd,TRUE);
      WinCheckButton(hwnd,IDRB_MERGESESSION,1);
    }
    else {
      WinCheckButton(hwnd,IDRB_MULTISESSION,1);
      thisPtr->cwEnableMultiSessionCntrls(hwnd,FALSE);
    }
  }
  else {// Singlesession selected. Disable the multisession stuff
    WinCheckButton(hwnd,IDRB_SINGLESESSION,1);
    /* Show tracktype controls */
    showMultiSessionCntrls(hwnd, FALSE);
  }
  /* Check tracktype button */
  if(ulFlags&IDCDT_TRACKDATA) 
    WinCheckButton(hwnd,IDRB_TRACKDATA,1);
  if(ulFlags&IDCDT_TRACKMODE2) 
    WinCheckButton(hwnd,IDRB_TRACKMODE2,1);
  if(ulFlags&IDCDT_TRACKXA1) 
    WinCheckButton(hwnd,IDRB_TRACKXA1,1);
  if(ulFlags&IDCDT_TRACKXA2) 
    WinCheckButton(hwnd,IDRB_TRACKXA2,1);
  if(ulFlags&IDCDT_TRACKCDI) 
    WinCheckButton(hwnd,IDRB_TRACKCDI,1);  
}


MRESULT EXPENTRY cdTypeOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  CWDataFolder* thisPtr;
  ULONG ulFlags;
  LONG lSpinValue;
  static HWND hwndStatus;
  int a;
  char chrCD[4];
  char text[CCHMAXPATH];
  char title[CCHMAXPATH];
  ULONG rc;

  switch(msg)
    {
    case WM_INITDLG :	
      WinSetWindowULong(WinWindowFromID(hwnd,IDPB_CDTYPEUNDO),
			QWL_USER,(ULONG)PVOIDFROMMP(mp2));//Save object ptr.
      ulFlags=((CWDataFolder*)PVOIDFROMMP(mp2))->cwQueryCDTypeFlags();
      enableCDTypeCntrls(hwnd,(CWDataFolder*)PVOIDFROMMP(mp2));
      if(ulFlags&IDCDT_FIXDISK) 
        WinCheckButton(hwnd,IDCB_FIXDISK,1);
      /* Insert CD-drives in dropdown box */
      /* for( a=0; a<iNumCD ;a++) {
         chrCD[0]=cFirstCD+a;
         chrCD[1]=':';
         chrCD[2]=0;
         WinSendMsg(WinWindowFromID(hwnd,IDDD_SOURCEDRIVE),LM_INSERTITEM,MPFROMSHORT(LIT_END),(MPARAM)chrCD);
         if(!a){
         if(!bMultiSessionDone)
         WinSetWindowText(WinWindowFromID(hwnd,IDDD_SOURCEDRIVE),chrCD);
         else
         WinSetWindowText(WinWindowFromID(hwnd,IDDD_SOURCEDRIVE),chosenMultiSessionCD);
         }
         }*/      
      return (MRESULT) TRUE;
      /*    case WM_HELP:
			thisPtr=(CWAudioFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_CDRECORDBROWSE),QWL_USER);
			if(!thisPtr)
            break;
			switch(WinQueryWindowUShort(WinQueryFocus(HWND_DESKTOP),QWS_ID))
            {
            case IDEF_CDRECORDOPTIONS:
            return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDOPTIONS,AFHELPLIBRARY);
            case IDPB_WIDERRUFEN:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_WIDERRUFEN,AFHELPLIBRARY);
            case IDPB_CDRECORDBROWSE:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_CDRECORDBROWSE,AFHELPLIBRARY);
            case IDEF_CDRECORDPATH:
            return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDPATH,AFHELPLIBRARY);
            default:
            break;
            }
			return (MRESULT)thisPtr->wpDisplayHelp(IDDLG_CDRECORDSETUP,AFHELPLIBRARY);
			break;*/
    case WM_DESTROY:
      /* The notebook closes and gets destroyed */
      /* Let the WPS save the new instance data */
      thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_CDTYPEUNDO),QWL_USER);
      if(thisPtr) {
        ulFlags=0;
        if(WinQueryButtonCheckstate(hwnd,IDRB_MULTISESSION)&1) {
          ulFlags|=IDCDT_MULTISESSION;
          ulFlags|=IDCDT_FIRSTSESSION;
        }
        if(WinQueryButtonCheckstate(hwnd,IDRB_MERGESESSION)&1) {
          ulFlags|=IDCDT_MERGESESSION;
          ulFlags|=IDCDT_MULTISESSION;
        }
        if(WinQueryButtonCheckstate(hwnd,IDRB_TRACKDATA)&1)
          ulFlags|=IDCDT_TRACKDATA;
        else
          if(WinQueryButtonCheckstate(hwnd,IDRB_TRACKMODE2)&1)
            ulFlags|=IDCDT_TRACKMODE2;
          else
            if(WinQueryButtonCheckstate(hwnd,IDRB_TRACKXA1)&1)
              ulFlags|=IDCDT_TRACKXA1;
            else
              if(WinQueryButtonCheckstate(hwnd,IDRB_TRACKXA2)&1)
                ulFlags|=IDCDT_TRACKXA2;
              else
                if(WinQueryButtonCheckstate(hwnd,IDRB_TRACKCDI)&1)
                  ulFlags|=IDCDT_TRACKCDI;
        if(WinQueryButtonCheckstate(hwnd,IDCB_FIXDISK)&1)
          ulFlags|=IDCDT_FIXDISK;
        thisPtr->cwSetCDTypeFlags(ulFlags,CDT_ALLFLAGS);
        thisPtr->wpSaveImmediate();
      }
      /* Destroy status window if not already done */
      /* if(WinIsWindow(WinQueryAnchorBlock(HWND_DESKTOP),hwndStatus)) {
         WinDestroyWindow(hwndStatus);
         hwndStatus=0;
         }*/
      /* Query the cd-drive for previous image */
      // WinQueryWindowText( WinWindowFromID(hwnd,IDDD_SOURCEDRIVE),sizeof(chosenMultiSessionCD),chosenMultiSessionCD);
      /* Setup is done */   
      bMultiSessionDone=TRUE;
      return (MRESULT) TRUE;
    case WM_CONTROL:
      thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_CDTYPEUNDO),QWL_USER);
      if(!thisPtr) return (MRESULT) TRUE;
      switch(SHORT1FROMMP(mp1))
        {
        case IDRB_SINGLESESSION:
          showMultiSessionCntrls(hwnd,FALSE);
          break;
        case IDRB_MULTISESSION:
          showMultiSessionCntrls(hwnd,TRUE);
          thisPtr->cwEnableMultiSessionCntrls(hwnd,FALSE);
          break;
        case IDRB_MERGESESSION:
          showMultiSessionCntrls(hwnd,TRUE);
          thisPtr->cwEnableMultiSessionCntrls(hwnd,TRUE);
          break;
          /*  case IDCB_FIRSTSESSION:
              if(WinQueryButtonCheckstate(hwnd,IDCB_FIRSTSESSION)&1) {
              thisPtr->cwEnableMultiSessionCntrls(hwnd,FALSE);
              WinEnableWindow(WinWindowFromID(hwnd,IDCB_FIRSTSESSION),TRUE);
              }
              else {
              thisPtr->cwEnableMultiSessionCntrls(hwnd,TRUE);
              if(WinQueryButtonCheckstate(hwnd,IDCB_WRITERSOURCE)&1) {
              WinEnableWindow(WinWindowFromID(hwnd,IDST_SOURCEDRIVE),FALSE);
              WinEnableWindow(WinWindowFromID(hwnd,IDDD_SOURCEDRIVE),FALSE);
              }      
              }
              break;
              case IDCB_WRITERSOURCE:
              if(WinQueryButtonCheckstate(hwnd,IDCB_WRITERSOURCE)&1){
              WinEnableWindow(WinWindowFromID(hwnd,IDDD_SOURCEDRIVE),FALSE);
              WinEnableWindow(WinWindowFromID(hwnd,IDST_SOURCEDRIVE),FALSE);
              }
              else {
              WinEnableWindow(WinWindowFromID(hwnd,IDDD_SOURCEDRIVE),TRUE);
              WinEnableWindow(WinWindowFromID(hwnd,IDST_SOURCEDRIVE),TRUE);
              }
              break;*/
        default:
          break;
        }
      break;
    case WM_COMMAND:	
      switch(SHORT1FROMMP(mp1))
        {
        case IDPB_CDTYPEUNDO:
          /* User pressed the UNDO button */
          thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_CDTYPEUNDO),QWL_USER);
          if(thisPtr) {
            ulFlags=thisPtr->cwQueryCDTypeFlags();
            /* Enable all multisesson controls */
            thisPtr->cwEnableMultiSessionCntrls(hwnd,TRUE);
            enableCDTypeCntrls(hwnd,thisPtr);
            if(ulFlags&IDCDT_FIXDISK) 
              WinCheckButton(hwnd,IDCB_FIXDISK,1);
            else
              WinCheckButton(hwnd,IDCB_FIXDISK,0);
          }
          break;  
        default:
          break;
        }
      return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2); 
}


/* This procedure handles the author settings page */ 
MRESULT EXPENTRY authorOptionDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) 
{
  CWDataFolder* thisPtr;

  switch(msg)
    {
    case WM_INITDLG :	
      WinSetWindowULong(WinWindowFromID(hwnd,IDPB_AUTHORUNDO),
                        QWL_USER,(ULONG)PVOIDFROMMP(mp2));//Save object ptr.
      thisPtr=(CWDataFolder*)PVOIDFROMMP(mp2);
      WinSendMsg(WinWindowFromID(hwnd,IDEF_APPLICATION),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)128),0);
      WinSetWindowText(WinWindowFromID(hwnd,IDEF_APPLICATION),thisPtr->chrApplication);
      WinSendMsg(WinWindowFromID(hwnd,IDEF_PUBLISHER),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)128),0);
      WinSetWindowText(WinWindowFromID(hwnd,IDEF_PUBLISHER),thisPtr->chrPublisher);
      WinSendMsg(WinWindowFromID(hwnd,IDEF_PREPARER),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)128),0);
      WinSetWindowText(WinWindowFromID(hwnd,IDEF_PREPARER),thisPtr->chrPreparer);
      //      WinSendMsg(WinWindowFromID(hwnd,IDEF_COPYRIGHT),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)37),0);
      //      WinSetWindowText(WinWindowFromID(hwnd,IDEF_COPYRIGHT),thisPtr->chrCopyright);
      WinSendMsg(WinWindowFromID(hwnd,IDEF_VOLUMENAME),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)37),0);
      WinSetWindowText(WinWindowFromID(hwnd,IDEF_VOLUMENAME),thisPtr->chrVolumeName);

      return (MRESULT) TRUE;
      /*    case WM_HELP:
			thisPtr=(CWAudioFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_CDRECORDBROWSE),QWL_USER);
			if(!thisPtr)
            break;
			switch(WinQueryWindowUShort(WinQueryFocus(HWND_DESKTOP),QWS_ID))
            {
            case IDEF_CDRECORDOPTIONS:
            return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDOPTIONS,AFHELPLIBRARY);
            case IDPB_WIDERRUFEN:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_WIDERRUFEN,AFHELPLIBRARY);
            case IDPB_CDRECORDBROWSE:
            return (MRESULT)thisPtr->wpDisplayHelp(IDPB_CDRECORDBROWSE,AFHELPLIBRARY);
            case IDEF_CDRECORDPATH:
            return (MRESULT)thisPtr->wpDisplayHelp(IDEF_CDRECORDPATH,AFHELPLIBRARY);
            default:
            break;
            }
			return (MRESULT)thisPtr->wpDisplayHelp(IDDLG_CDRECORDSETUP,AFHELPLIBRARY);
			break;*/
    case WM_DESTROY:
      /* The notebook closes and gets destroyed */

      /* Let the WPS save the new instance data */
      thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_AUTHORUNDO),QWL_USER);
      if(thisPtr) {
        WinQueryWindowText( WinWindowFromID(hwnd,IDEF_APPLICATION),sizeof(thisPtr->chrApplication),thisPtr->chrApplication);
        WinQueryWindowText( WinWindowFromID(hwnd,IDEF_PUBLISHER),sizeof(thisPtr->chrPublisher),thisPtr->chrPublisher);
        WinQueryWindowText( WinWindowFromID(hwnd,IDEF_PREPARER),sizeof(thisPtr->chrPreparer),thisPtr->chrPreparer);
        WinQueryWindowText( WinWindowFromID(hwnd,IDEF_COPYRIGHT),sizeof(thisPtr->chrCopyright),thisPtr->chrCopyright);
        WinQueryWindowText( WinWindowFromID(hwnd,IDEF_VOLUMENAME),sizeof(thisPtr->chrVolumeName),thisPtr->chrVolumeName);
        thisPtr->wpSaveDeferred();
      }
      /* Setup is done */
      return (MRESULT) TRUE;
    case WM_COMMAND:	
    switch(SHORT1FROMMP(mp1))
      {
      case IDPB_AUTHORUNDO:
        /* User pressed the UNDO button */
        thisPtr=(CWDataFolder*) WinQueryWindowULong(WinWindowFromID(hwnd,IDPB_AUTHORUNDO),QWL_USER);
        if(thisPtr) {
          WinSetWindowText(WinWindowFromID(hwnd,IDEF_APPLICATION),thisPtr->chrApplication);
          WinSetWindowText(WinWindowFromID(hwnd,IDEF_PUBLISHER),thisPtr->chrPublisher);
          WinSetWindowText(WinWindowFromID(hwnd,IDEF_PREPARER),thisPtr->chrPreparer);
          WinSetWindowText(WinWindowFromID(hwnd,IDEF_COPYRIGHT),thisPtr->chrCopyright);
          WinSetWindowText(WinWindowFromID(hwnd,IDEF_VOLUMENAME),thisPtr->chrVolumeName);
        }
        break;
      default:
        break;
      }
    return (MRESULT) TRUE;
    default:
      break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}















