/*
 * This file is (C) Chris Wohlgemuth 1999
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#define INCL_DOS
#define INCL_WIN

#include <os2.h>
#include "audiofolder.h"
#define SHAREDMEM_SIZE 8092 /* Max size of mkisofs cmd line */
#define STATUS_LENGTH 200
#define AUDIOSHAREDMEM_SIZE    8192


#pragma SOMAsDefault(on)
#include <som.hh>
#include <somcls.hh>
#pragma SOMNoMangling(on)
#include "progfolder.h"
#include "progfolder.hh"


class M_CWAudioFolder:public M_CWProgFolder
{
/* The name of of the new class */
#pragma SOMClassName(*,"M_CWAudioFolder")
/* Required SOM version */
#pragma SOMClassVersion(*,1,2)
#pragma SOMCallstyle(oidl)
public:
	virtual PSZ  wpclsQueryTitle();
	virtual	ULONG wpclsQueryIconData(PICONINFO pIconInfo);
	virtual	ULONG wpclsQueryIconDataN(PICONINFO pIconInfo, ULONG ulIconIndex);
	virtual	ULONG wpclsQueryStyle();
	virtual BOOL wpclsQueryDefaultHelp(PULONG HelpPanelId,PSZ HelpLibrary);
	virtual void wpclsInitData();
  virtual void wpclsUnInitData();
#pragma SOMReleaseOrder()
};

class CWAudioFolder:public CWProgFolder
{
#pragma SOMClassName(*,"CWAudioFolder")
#pragma SOMMetaClass(CWAudioFolder,"M_CWAudioFolder")
#pragma SOMClassVersion(CWAudioFolder,1,2)
#pragma SOMCallstyle(oidl)
private:
  ULONG ulWriteFlags;
  BOOL bGrabEnabled;
  BOOL bWriteEnabled;
public:		
  BOOL bShowGrab;
  HWND hwndGrab;
  HWND hwndWrite;
  HWND hwndStatus;
  HWND hwndSelect;
  HWND hwndStatusFrameCtl;
  HWND hwndWriteStatus;
  HWND hwndWriteLB;
  ULONG ulTrackSize;
	
  SHORT a;
  int b;
  int numTracks;
  int tid;
  int tidWrite;
  int aWrite;
  int bWrite;
  virtual BOOL wpMenuItemHelpSelected(ULONG MenuId);
  virtual ULONG wpFilterPopupMenu(ULONG ulFlags, HWND hwndCnr, BOOL fMultiSelect);
  virtual BOOL wpModifyPopupMenu(HWND hwndMenu, HWND hwndCnr, ULONG ulPosition);
  virtual BOOL wpMenuItemSelected(HWND hwndFrame,ULONG ulMenuId);
  virtual ULONG wpAddFolderView2Page(HWND hwndNotebook);
  //virtual ULONG wpAddObjectGeneralPage2(HWND hwndNotebook);
  virtual BOOL wpAddSettingsPages(HWND hwndNotebook);
  virtual BOOL AddCdrecordOptionPage(HWND hwndNotebook);
  virtual BOOL wpPopulate(ULONG ulReserved,PSZ Folder,BOOL fFoldersOnly);
  virtual BOOL wpAddToContent(WPObject* Object);
  virtual BOOL wpDeleteFromContent(WPObject* Object);
  virtual BOOL cwIsWaveFile(WPObject* wpObject);
  virtual ULONG cwSetWriteFlags(ULONG ulNewWriteFlags,ULONG ulMask);
  virtual ULONG cwQueryWriteFlags();
  virtual BOOL AddGrabOptionPage(HWND hwndNotebook);
  virtual BOOL wpRestoreState(ULONG ulReserved);
  virtual BOOL wpSaveState();	
  virtual HWND wpOpen(HWND hwndCnr,ULONG ulView,ULONG ulParam);
  //	virtual WPObject* wpQueryContent(WPObject* Object,ULONG ulOption);
  virtual MRESULT wpDrop(HWND hwndCnr,PDRAGINFO pDragInfo,PDRAGITEM pDragItem);
  //	virtual PMINIRECORDCORE wpCnrInsertObject(HWND hwndCnr,PPOINTL pIcon,PMINIRECORDCORE pParent,PRECORDINSERT pRecInsert);
  virtual BOOL wpSetupOnce(PSZ pSetupString);
  virtual BOOL wpSetup(PSZ pSetupString);
  virtual void wpCopiedFromTemplate();
  virtual void cwEnableGrab(BOOL bEnable);
  virtual BOOL cwQueryGrabEnabled(void);
  virtual void cwEnableGrabControls(BOOL bEnable);
  virtual void cwEnableSelectControls(BOOL bEnable);
  virtual ULONG cwFillTrackList(HWND hwndFrame, HWND hwndListBox);
  virtual void cwSetStatusTime(ULONG ulTrackSize);
  virtual void cwSetStatusText(char * text);
  virtual void cwForceStatusUpdate(void);
  virtual void cwEnableWrite(BOOL bEnable);
  virtual BOOL cwQueryWriteEnabled(void);
  virtual void cwEnableWriteControls(BOOL bEnable);
  virtual void cwWriteAudioTracks(HWND hwnd, char* trackName, char* folderName);
  virtual BOOL AddMpg123OptionPage(HWND hwndNotebook);
  virtual BOOL cwIsMp3File(WPObject* wpObject);
  virtual BOOL AddCdrdaoOptionPage(HWND hwndNotebook);
  virtual BOOL cwAddGeneralOptionPage(HWND hwndNotebook);
#pragma SOMReleaseOrder(\
"AddCdrecordOptionPage",\
"cwIsWaveFile",\
"cwSetWriteFlags",\
"cwQueryWriteFlags",\
"AddGrabOptionPage",\
"cwEnableGrab",\
"cwQueryGrabEnabled",\
"cwEnableGrabControls",\
"cwEnableSelectControls",\
"cwFillTrackList",\
"cwSetStatusTime",\
"cwForceStatusUpdate",\
"cwEnableWrite",\
"cwQueryWriteEnabled",\
"cwEnableWriteControls",\
"cwSetStatusText", \
"cwWriteAudioTracks", \
"AddMpg123OptionPage", \
"cwIsMp3File", \
"AddCdrdaoOptionPage", \
"cwAddGeneralOptionPage" )
};

class M_CWDataFolder:public M_CWProgFolder
{
#pragma SOMClassName(*,"M_CWDataFolder")
#pragma SOMClassVersion(*,1,2)
#pragma SOMCallstyle(oidl)
public:
  virtual PSZ  wpclsQueryTitle();
  virtual	ULONG wpclsQueryIconData(PICONINFO pIconInfo);
  virtual	ULONG wpclsQueryIconDataN(PICONINFO pIconInfo, ULONG ulIconIndex);
  virtual	ULONG wpclsQueryStyle();
  virtual BOOL wpclsQueryDefaultHelp(PULONG HelpPanelId,PSZ HelpLibrary);
  	virtual void wpclsInitData();
  virtual void wpclsUnInitData();
#pragma SOMReleaseOrder()
};

class CWDataFolder:public CWProgFolder
{
#pragma SOMClassName(*,"CWDataFolder")
#pragma SOMMetaClass(CWDataFolder,"M_CWDataFolder")
#pragma SOMClassVersion(CWDataFolder,1,2)
#pragma SOMCallstyle(oidl)
private:
  ULONG ulMkisofsFlags;
  ULONG ulCDTypeFlags;
  ULONG ulCreateFlags;
  LONG lPreviousStart;
  LONG lNextStart;
  WPObject *tbObject;
public:		
  SHORT sDummy;
  HWND hwndImageName;
  HWND hwndMkisofsMain;
  HWND hwndStatusCntrl;
  BOOL bCreate;

  char chrApplication[128+1];
  char chrPublisher[128+1];
  char chrPreparer[128+1];
  char chrCopyright[37+1];
  char chrVolumeName[37+1];
  char chrStatusText[STATUS_LENGTH];

  /*  virtual void wpInitData();
      virtual BOOL wpMenuItemHelpSelected(ULONG MenuId);
      virtual ULONG wpFilterPopupMenu(ULONG ulFlags, HWND hwndCnr, BOOL fMultiSelect);*/
  virtual BOOL wpModifyPopupMenu(HWND hwndMenu, HWND hwndCnr, ULONG ulPosition);
  virtual BOOL wpMenuItemSelected(HWND hwndFrame,ULONG ulMenuId);
  virtual BOOL wpSetup(PSZ pSetupString);
  virtual BOOL wpClose();
  virtual void wpCopiedFromTemplate();
  virtual BOOL wpAddSettingsPages(HWND hwndNotebook);
  virtual BOOL AddCdrecordOptionPage(HWND hwndNotebook);
  virtual BOOL AddMkisofsOptionPage(HWND hwndNotebook);
  virtual BOOL AddFileNameOptionPage(HWND hwndNotebook);
  virtual ULONG cwSetMkisofsFlags(ULONG ulNewMkisofsFlags,ULONG ulMask);
  virtual ULONG cwQueryMkisofsFlags();
  virtual BOOL wpRestoreState(ULONG ulReserved);
  virtual BOOL wpSaveState();	
  virtual HWND wpOpen(HWND hwndCnr,ULONG ulView,ULONG ulParam);
  virtual void cwCreateImage();
  virtual BOOL AddCDTypeOptionPage(HWND hwndNotebook);
  virtual LONG cwQueryPreviousStartSector();
  virtual LONG cwQueryNextStartSector();
  virtual void cwSetPreviousStartSector(LONG lSector);
  virtual void cwSetNextStartSector(LONG lSector);
  virtual ULONG cwSetCDTypeFlags(ULONG ulNewCDTypeFlags,ULONG ulMask);
  virtual ULONG cwQueryCDTypeFlags();
  virtual void cwEnableMultiSessionCntrls(HWND hwnd, BOOL bEnable);
  virtual BOOL AddAuthorOptionPage(HWND);
  virtual void cwWriteImage();
  virtual void cwSetStatusText(PSZ pszText);
  //  virtual BOOL AddCreateOptionPage(HWND hwndNotebook);
  virtual ULONG cwSetCreateFlags(ULONG ulNewCreateFlags,ULONG ulMask);
  virtual ULONG cwQueryCreateFlags();
  virtual void cwWriteOnTheFly();
  /*   virtual MRESULT wpDrop(HWND hwndCnr,PDRAGINFO pDragInfo,PDRAGITEM pDragItem);
      virtual BOOL wpSetupOnce(PSZ pSetupString);
      virtual void wpCopiedFromTemplate();*/
  virtual void cwEnableWriteControls(BOOL bEnable);
  virtual void cwGetImageSize();
  virtual void cwShowImageName(BOOL bShow);
  virtual BOOL cwAddGeneralOptionPage(HWND hwndNotebook);
#pragma SOMReleaseOrder(\
"AddCdrecordOptionPage",\
"AddMkisofsOptionPage",\
"AddFileNameOptionPage",\
"cwSetMkisofsFlags",\
"cwQueryMkisofsFlags",\
"cwCreateImage",\
"AddCDTypeOptionPage",\
"cwQueryPreviousStartSector",\
"cwQueryNextStartSector",\
"cwSetPreviousStartSector",\
"cwSetNextStartSector",\
"cwSetCDTypeFlags",\
"cwQueryCDTypeFlags",\
"cwEnableMultiSessionCntrls",\
"AddAuthorOptionPage",\
"cwWriteImage",\
"cwSetStatusText",\
"cwSetCreateFlags",\
"cwQueryCreateFlags",\
"cwWriteOnTheFly",\
"cwEnableWriteControls",\
"cwGetImageSize",\
"cwShowImageName",\
"cwAddGeneralOptionPage")
};















