/*           Install the Audio-CD-Folder/Data-CD-Folder 
 *
 *                   (C) Chris Wohlgemuth 1999/2000
*/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

 call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
 call SysLoadFuncs

/* Clear screen */
'cls'
pmconfig.exe
if rc\=0 then exit

/* Get curent directory */
curdir = directory()

say 'Current directory is' curdir
say ''

say 'Registering class ''CWProgFolder''...'

if SysRegisterObjectClass("CWProgFolder",'progfldr')<>1 then
	do	 	
                say ''
		say 'Error while registering class ''CWProgFolder'''
		del boot
		say 'Exiting...'
		exit 	
	end 

audiofolderdll=curdir'\aucdfldr.dll'

say 'Registering class ''CWAudioFolder''...'
if SysRegisterObjectClass("CWAudioFolder",audiofolderdll)<>1 then
	do	 	
                say ''
		say 'Error while registering class ''CWAudioFolder'''
		say 'Deregistering class ''CWProgFolder'''
		if SysDeregisterObjectClass("CWProgFolder") <>1 then
			say 'Error while deregistering class ''CWProgFolder'''
		del boot
		say 'Exiting...'
		say 'After reboot delete file 'boot
		exit 	
	end 

say 'Registering class ''CWDataFolder''...'
if SysRegisterObjectClass("CWDataFolder",audiofolderdll)<>1 then
	do	 	
                say ''
		say 'Error while registering class ''CWDataFolder'''
		say 'Deregistering class ''CWAudioFolder'''
		if SysDeregisterObjectClass("CWAudioFolder") <>1 then
			say 'Error while deregistering class ''CWAudioFolder'''
		say 'Deregistering class ''CWProgFolder'''
		if SysDeregisterObjectClass("CWProgFolder") <>1 then
			say 'Error while deregistering class ''CWProgFolder'''
		del boot
                del audiofolderdll
		say 'Exiting...'
		say 'After reboot delete file 'boot
		exit 	
	end 

say 'Customizing the template in the templates folder...'
if SysCreateObject("CWAudioFolder","Audio-CD-Creator","<WP_TEMPS>","OBJECTID=<AUDIOCD_CREATOR>;TEMPLATE=YES;FLDRWRITEFLAGS=11;BACKGROUND="curdir"\music.jpg,T,,I","update")<>1 then
             say '     Can''t update the template.'
if SysCreateObject("CWDataFolder","Data-CD-Creator","<WP_TEMPS>","OBJECTID=<DATACD_CREATOR>;TEMPLATE=YES;FLDRFILENAMEOPTIONS=31;FLDRCREATEOPTIONS=1;BACKGROUND="curdir"\DATACD.jpg,S,1,I","update")<>1 then
             say '     Can''t update the template.'

say 'Creating a CD-Writing folder on the desktop...'
if SysCreateObject("WPFolder","CD-Writing Utilities","<WP_DESKTOP>","OBJECTID=<CD_WRITING>","update")<>1 then
             do
                say ''
                say 'Can''t create the folder. Exciting...'
		say 'You''ll find a template in your templates folder.'
		exit
             end

setupstring='EXENAME='curdir'\cdrtools.exe;STARTUPDIR='curdir

say 'Creating an object for CDRTools...'
if SysCreateObject("WPProgram","CDR-Tools","<CD_WRITING>",setupstring,"update")<>1 then
		do
              say ''
              say 'Can''t create a program object for CDRTools.exe.'
              say 'You can find CDRTools in 'curdir
              say '' 
            end

say 'Creating a shadow for the documentation folder...'
setupstring='SHADOWID='curdir'\Docs'
if SysCreateObject("WPShadow","Docs","<CD_WRITING>",setupstring,"update")<>1 then
	do
              say 'Can''t create the shadow for the folder.'
	      say 'Perhaps on FAT-Drive not HPFS...'
	end

say 'Creating a shadow of the Audio-CD-Creator in the CD-Writing folder...'
if SysCreateObject("WPShadow","Audio-CD-Creator","<CD_WRITING>","SHADOWID=<AUDIOCD_CREATOR>","update")<>1 then
              say 'Can''t create the shadow.'

say 'Creating a shadow of the Data-CD-Creator in the CD-Writing folder...'
if SysCreateObject("WPShadow","Data-CD-Creator","<CD_WRITING>","SHADOWID=<DATACD_CREATOR>","update")<>1 then
              say 'Can''t create the shadow.'


/* Open the CD-writing folder */
rc=SysSetObjectData("<CD_WRITING>","OPEN=DEFAULT")



say ''
say 'The Audio-CD-Creator and Data-CD-Creator'
say 'were installed succesful.'
say 'You''ll find templates in your templates folder for creating'
say 'Audio-CD and Data-CD projects.'
say 'Before starting to write you have to enter the path to each helper'
say 'program in the settings notebook!'
say ''
say 'Have fun :-) !!'

say ''
say ''
say 'Press <ENTER>'
say ''
say '>'
parse value SysCurPos() with aktzeile aktspalte
newposition=SysCurPos(aktzeile-1,2)
pull

exit

