#define INCL_WIN
#define INCL_DOS
#define INCL_DOSERRORS

#include <os2.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <stdio.h>
#include "audiofolder.h"
#include "audiofolderres.h"

#define INSTALLDIR 1


extern char* params[];
extern HMODULE RESSOURCEHANDLE;
extern char logName[];

char chrCDRecord[CCHMAXPATH];/* Path to cdrecord */
char chrCDROptions[CCHMAXPATH];
char chrAudioCDROptions[CCHMAXPATH];
LONG  lCDROptions=0;

char chrMkisofs[CCHMAXPATH];/* Path to mkisofs */
char chrMkisofsOptions[CCHMAXPATH];
LONG lMKOptions;

char chrGrabberPath[CCHMAXPATH];
char chrGrabberOptions[CCHMAXPATH];
int bTrackNumbers;
char chosenCD[3];

char chrMpg123Path[CCHMAXPATH];
BOOL bMpg123SwabBytes;

char chrCdrdaoPath[CCHMAXPATH]={0};
char chrCdrdaoDriver[100]={0};
int iBus=0;
int iTarget=0;
int iLun=0;
int iSpeed=1;
int iFifo=4;

void removeLog(void)
{
  char logNameLocal[CCHMAXPATH];

  sprintf(logNameLocal,"%s\\%s",params[1],logName);
  remove(logNameLocal);
}

void writeLog(char* logText)
{
  char logNameLocal[CCHMAXPATH];
  FILE *fHandle;

  sprintf(logNameLocal,"%s\\%s",params[1],logName);
  fHandle=fopen(logNameLocal,"a");
  if(fHandle) {
    fprintf(fHandle,logText);
    fclose(fHandle);
  }
}

/* This function launches the writer with the params given */
/* in PSZ parameter. PSZ folderPath is the path to put the */
/* write.log. HWND hwnd is the window waiting for the      */
/* WM_APPTERMINATE message                                 */
ULONG launchWrapper(PSZ parameter, PSZ folderPath,HWND hwnd, PSZ wrapperExe, PSZ pszTitle)
{
  STARTDATA startData={0};
  APIRET rc;
  PID pid;
  ULONG ulSessionID=0;
  char chrLoadError[CCHMAXPATH];
  char startParams[CCHMAXPATH*4];
  char exename[CCHMAXPATH]={0};
  char chrCDRexe[CCHMAXPATH+10];
  struct stat statBuf;

  sprintf(exename,"%s\\%s",params[1],wrapperExe);
  /* Check if the VIO helper is in the install dir */
  if(stat(exename , &statBuf)==-1) {
    /* text: "Can't find the helper program %s. It should be in the installation directory of Audio/Data-CD-Creator."
       title: "Audio/Data-CD-Creator installation problem!"
       */
    getMessage(chrLoadError, IDSTR_INSTALLNOVIO, sizeof(chrLoadError), RESSOURCEHANDLE , hwnd);
    sprintf(startParams,chrLoadError,wrapperExe);
    getMessage(chrLoadError, IDSTR_INSTALLERRORTITLE, sizeof(chrLoadError), RESSOURCEHANDLE , hwnd);
    WinMessageBox(HWND_DESKTOP,0,
                  startParams,
                  chrLoadError,12345,
                  MB_OK|MB_MOVEABLE|MB_ERROR);
    return -1;
  }

  writeLog("Starting vio helper '");
  writeLog(wrapperExe);  
  writeLog("'\n");
      
  memset(&startData,0,sizeof(startData));
  startData.Length=sizeof(startData);
  startData.Related=SSF_RELATED_INDEPENDENT;
  startData.FgBg=SSF_FGBG_FORE;
  startData.TraceOpt=SSF_TRACEOPT_NONE;
  startData.PgmTitle=pszTitle;
    
  
  startData.PgmName=exename;
  startData.InheritOpt=SSF_INHERTOPT_SHELL;
  startData.SessionType=SSF_TYPE_WINDOWABLEVIO;
  startData.PgmControl=0;
  if(lCDROptions&IDCDR_HIDEWINDOW)
    startData.PgmControl|=SSF_CONTROL_INVISIBLE;//|SSF_CONTROL_MAXIMIZE|SSF_CONTROL_NOAUTOCLOSE;
  if(!(lCDROptions&IDCDR_CLOSEWINDOW))
    startData.PgmControl|=SSF_CONTROL_NOAUTOCLOSE;
  startData.InitXPos=30;
  startData.InitYPos=30;
  startData.InitXSize=500;
  startData.InitYSize=400;
  startData.ObjectBuffer=chrLoadError;
  startData.ObjectBuffLen=(ULONG)sizeof(chrLoadError);

  /* Put the exe-path between " " to make sure, spaces are handled correctly */
  sprintf(chrCDRexe,"\"%s\"",chrCDRecord);
  if(strlen(folderPath)!=0)
    sprintf(startParams,"%d %s \"%s\" %s",hwnd,chrCDRexe,folderPath ,parameter);
  else
    sprintf(startParams,"%d %s %s",hwnd,chrCDRexe, parameter);
  startData.PgmInputs=startParams;
 
  rc=DosStartSession(&startData,&ulSessionID,&pid);   
  if(rc!=NO_ERROR) {
    writeLog("Error while starting VIO helper: ");
    sprintf(chrLoadError,"%d\n",rc);
    writeLog(chrLoadError);
  }
  return 0;   
}


BOOL readIni()
{
  ULONG keyLength;
  char profileName[CCHMAXPATH];
  char moduleName[CCHMAXPATH];
  char *chrPtr;
  char *chrPtr2;
  HINI hini=0;
  char    text[200];
  ULONG ulSize;
  int a;
  char chrCD[4];
  BOOL bError=FALSE;
  HWND hwnd;

  hwnd=HWND_DESKTOP;

  /* Insert message in Logfile */
  writeLog("Reading values from cdrecord.ini\n");

  /* Build full path for cdrecord.ini file */
  sprintf(profileName,"%s\\cdrecord.ini", params[1]);       
  /* Open ini-file */
  hini=PrfOpenProfile(WinQueryAnchorBlock(HWND_DESKTOP),(unsigned char *)profileName);
  do{
    if(!hini) {
      /* profileName: "Warning! Cannot open Ini-file!"
         moduleName: "Data-CD-Creator"
         */
      messageBox( profileName, IDSTR_INIFILEOPENERROR , sizeof(profileName),
                  moduleName, IDSTRD_DATACDCREATOR, sizeof(moduleName),
                  RESSOURCEHANDLE, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
      break;
    }/* end of if(!hini) */

    keyLength=PrfQueryProfileString(hini,"CDWriter","cdrecord","",chrCDRecord,sizeof(chrCDRecord));
    if(keyLength==1){
      /* Text: "No CDRecord/2 path in cdrecord.ini found!\n" */
      getMessage(text, IDSTRLOG_NOCDRECORD, sizeof(text), RESSOURCEHANDLE , hwnd);      
      writeLog(text);
      writeLog("\n");
      bError=TRUE;
      //  break;/* First opening. We havn't got entries yet */
    }

    ulSize=sizeof(lCDROptions); 
    PrfQueryProfileData(hini,"CDWriter","options",&lCDROptions,&ulSize);

    PrfQueryProfileString(hini,"CDWriter","audiocdroptions","",chrAudioCDROptions,sizeof(chrAudioCDROptions));    
    PrfQueryProfileString(hini,"CDWriter","cdroptions","",chrCDROptions,sizeof(chrCDROptions));    

    ulSize=sizeof(lCDROptions); 
    PrfQueryProfileData(hini,"CDWriter","options",&lCDROptions,&ulSize);
    keyLength=PrfQueryProfileString(hini,"Mkisofs","mkisofs","",chrMkisofs,sizeof(chrMkisofs));
    if(keyLength==1){
      /* Text: "No mkisofs path in cdrecord.ini found!\n" */
      getMessage(text, IDSTRLOG_NOMKISOFS, sizeof(text), RESSOURCEHANDLE , hwnd);      
      writeLog(text);
      writeLog("\n");
      bError=TRUE;
      //break;/* First opening. We havn't got entries yet */
    }

    PrfQueryProfileString(hini,"Mkisofs","mkisofsoptions","",chrMkisofsOptions,sizeof(chrMkisofsOptions));
    //lMKOptions=PrfQueryProfileInt(hini,"Mkisofs","options",IDMK_HIDEWINDOW|IDMK_CLOSEWINDOW);
    ulSize=sizeof(lMKOptions);
    PrfQueryProfileData(hini,"Mkisofs","options",&lMKOptions,&ulSize);   

    keyLength=PrfQueryProfileString(hini,"CDGrabber","grabber","",chrGrabberPath,sizeof(chrGrabberPath));
    if(keyLength==1){
      /* Text: "No grabber path in cdrecord.ini found!\n" */
      getMessage(text, IDSTRLOG_NOGRABBER, sizeof(text), RESSOURCEHANDLE , hwnd);      
      writeLog(text);
      writeLog("\n");
      bError=TRUE;
      //break;/* We havn't got entries yet */
    }
    PrfQueryProfileString(hini,"CDGrabber","graboptions","",chrGrabberOptions,sizeof(chrGrabberOptions));
    PrfQueryProfileString(hini,"CDGrabber","grabdrive","",chosenCD,sizeof(chosenCD));
    bTrackNumbers=PrfQueryProfileInt(hini,"CDGrabber","tracknumbers",1);

    keyLength=PrfQueryProfileString(hini,"mpg123","path","",chrMpg123Path,sizeof(chrMpg123Path));
    if(keyLength==1){
      /* Text: "No mpg123 path in cdrecord.ini found!\n" */
      getMessage(text, IDSTRLOG_NOMPG123, sizeof(text), RESSOURCEHANDLE , hwnd);      
      writeLog(text);
      writeLog("\n");
      bError=TRUE;
      //      break;/* We havn't got entries yet */
    }
    bMpg123SwabBytes=PrfQueryProfileInt(hini,"mpg123","swabbytes",1);

    keyLength=PrfQueryProfileString(hini,"cdrdao","path","",chrCdrdaoPath,sizeof(chrCdrdaoPath));
    if(keyLength==1){
      /* Text: "No cdrdao/2 path in cdrecord.ini found!\n" */
      getMessage(text, IDSTRLOG_NOCDRDAO, sizeof(text), RESSOURCEHANDLE , hwnd);      
      writeLog(text);
      writeLog("\n");
      bError=TRUE;
      //      break; /* We havn't got entries yet */
    }

    keyLength=PrfQueryProfileString(hini,"cdrdao","driver","",chrCdrdaoDriver,sizeof(chrCdrdaoDriver));
    if(keyLength==1){
      /* Text: "No driver for cdrdao/2 found in cdrecord.ini!\n" */
      getMessage(text, IDSTRLOG_NOCDRDAODRIVER, sizeof(text), RESSOURCEHANDLE , hwnd);      
      writeLog(text);
      writeLog("\n");
      bError=TRUE;
     /* We havn't got entries yet */
      //break;
    }

    iBus=PrfQueryProfileInt(hini,"device","bus",0);
    iTarget=PrfQueryProfileInt(hini,"device","target",0);
    iLun=PrfQueryProfileInt(hini,"device","lun",0);
    iSpeed=PrfQueryProfileInt(hini,"device","speed",1);
    iFifo=PrfQueryProfileInt(hini,"device","fifo",4);

    if(hini)
      PrfCloseProfile(hini);

    if(bError)
      break;
    return TRUE;
  } while(TRUE);
  writeLog("Error while reading cdrecord.ini\n");
  return FALSE;
}

void queryFreeCDSpaceError(HWND hwnd) {
  char text[CCHMAXPATH];
  char title[CCHMAXPATH];

  /* Text: "Can't get free CD space!" */
  getMessage(text, IDSTRLB_CDSPACEERROR, sizeof(text), RESSOURCEHANDLE , hwnd);
  WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(0),text);            

  DosBeep(100,300);
  /* Title: "Writing audio CD"
     Text: "Can't query free CD space! Aborting..."
     */
  writeLog(text);
  writeLog("\n");
  messageBox( text, IDSTRPM_CDSPACEERROR , sizeof(text),
              title, IDSTRPM_DAOTITLE , sizeof(title),
              RESSOURCEHANDLE, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
  WinPostMsg(hwnd,WM_QUIT,0,0);
}

BOOL queryFreeCDSpace(HWND hwnd) {
  char text[CCHMAXPATH];
  char title[CCHMAXPATH];

  /* Text: "Querying free CD space. Please wait..." */
  getMessage(text, IDSTRD_QUERYFREECDSPACE, sizeof(text), RESSOURCEHANDLE , hwnd);
  writeLog(text);
  writeLog("\n");
  /* Insert text into listbox */     
  WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(0),
             text);        

  sprintf(text,"dev=%d,%d,%d",iBus,iTarget,iLun);

  /* Launch the helper */
  /* Title: "Query CD size" */
  getMessage(title, IDSTRVIO_CDSIZE, sizeof(title), RESSOURCEHANDLE , hwnd);
  launchWrapper(text, "", hwnd,"cdsize.exe",title);
  return FALSE;
}

/* This function returns the module handle of our ressource dll */
HMODULE queryResModuleHandle()
{
  COUNTRYCODE country= {0};
  COUNTRYINFO countryInfo= {0};
  char path[CCHMAXPATH];  
  char buf[CCHMAXPATH];
  char* found;
  APIRET rc;
  ULONG ulInfoLen;
    
  if(!RESSOURCEHANDLE) {
    /* Get the country code of our system and load the  
       resource DLL with the right language */
    do {
      rc=DosQueryCtryInfo(sizeof(countryInfo),&country,&countryInfo,&ulInfoLen);
      if(rc!=NO_ERROR)
        break;

      sprintf(path,"%s",params[INSTALLDIR]);
      
      sprintf(buf,"\\cdfld%03d.dll",countryInfo.country);
      
      strcat(path,buf);
      //WinMessageBox(  HWND_DESKTOP,0, path, "Search DLL...", 0UL, MB_YESNO | MB_ICONEXCLAMATION|MB_MOVEABLE );
      rc=DosLoadModule(buf,sizeof(buf),path, &RESSOURCEHANDLE);
      if(rc==NO_ERROR)
        break;
      
      /* NLS DLL not found. Try to load default */
      found=strrchr(path,'\\');
      if(!found)
        break;

      *found=0;
      sprintf(buf,"\\cdfld001.dll");
      strcat(path,buf);
      rc=DosLoadModule(buf,sizeof(buf),path, &RESSOURCEHANDLE);
      if(rc!=NO_ERROR)
        RESSOURCEHANDLE=NULLHANDLE;
      break;
    }while(TRUE);
  }
  return RESSOURCEHANDLE;
}

void freeResHandle()
{
  if(RESSOURCEHANDLE)
    DosFreeModule(RESSOURCEHANDLE);
}

void sendCommand(PSZ command)
{
  HOBJECT hObject;
  char chrCommand[CCHMAXPATH];

  hObject=WinQueryObject(params[2]);
  sprintf(chrCommand,"Querying object pointer for: %s\n",params[2]);
  writeLog(chrCommand);
  if(hObject!=NULLHANDLE) {
    strcpy(chrCommand,command);
    WinSetObjectData(hObject,chrCommand);
    writeLog("Sending command to folder: ");
    writeLog(command);
    writeLog("\n");
  }
  else {
    sprintf(chrCommand,"Can't query object pointer for: %s\n",params[2]);
    writeLog(chrCommand);
  }
}








