/*
 * pmauddao.cpp (C) Chris Wohlgemuth 2000
 *
 * This helper handles the GUI stuff for onthefly CD creation
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */          
#define INCL_DOS
#define INCL_DOSFILEMGR
#define INCL_DOSERRORS
#define INCL_WIN

#include <os2.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include "progbars.h"
#include "audiofolder.h"
#include "audiofolderres.h"

void pmUsage();

//#define DEBUG
extern char chrCdrdaoPath[CCHMAXPATH];
extern char chrCdrdaoDriver[CCHMAXPATH];
extern char chrCDRecord[CCHMAXPATH];/* Path to cdrecord */
extern LONG  lCDROptions;

char logName[CCHMAXPATH]="pmauddao.log";

PVOID pvSharedMem;
char *ptrTrack;
char *ptrTrack2;
char * pipePtr;
int numTracks=0;
int currentTrack=1;
BOOL bNofix=FALSE;
ULONG ulTrackSize=0;
ULONG ulTotalWritten=0;
ULONG ulTotalSize=0;
BOOL bDecodingMp3=FALSE;

int numArgs;
char* params[99+4];
/* params[0]: progname
 * params[1]: installdir of Audio-CD-Creator
 * params[2]: foldername
 * params[3]: # tracks
 * params[4]: size of all tracks in bytes
 */

/* The cdrecord start params and the names of the audio files are copied to shared mem
by the classes. This helper gets \\SHAREMEM\\AUDIOCMDLINE memory during processing of
WM_INITDLG. */

HMODULE RESSOURCEHANDLE=0;

//void sendCommand(PSZ command);
void removeLog(void);
void writeLog(char* logText);
void queryFreeCDSpaceError(HWND hwnd);
BOOL queryFreeCDSpace(HWND hwnd);

void writeDAO(HWND hwnd) {
  char text[CCHMAXPATH];

  /* Text: "Write audio (DAO) VIO helper" */
  getMessage(text, IDSTRVIO_WRITEAUDIODAO, sizeof(text), RESSOURCEHANDLE , hwnd);

  /* Start writer here */ 
  launchWrapper("",params[2],hwnd,"wrtaudao.exe",text);

}

/* This Proc handles the on-the-fly data CD writing */
MRESULT EXPENTRY audioStatusDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  char text[CCHMAXPATH];
  char title[CCHMAXPATH];
  char *textPtr;
  char *textPtr2; 
  ULONG rc;
  SWCNTRL swctl;
  PID pid;
  static BOOL bAbort;
  LONG lTemp;
  static int iStatus;

  switch (msg)
    {      
    case WM_INITDLG:   
      writeLog("Initializing dialog...\n");  
      if(DosGetNamedSharedMem(&pvSharedMem,"\\SHAREMEM\\AUDIOCMDLINE",PAG_READ|PAG_WRITE)) {
        /* Text: "Can't alloc shared memory! Aborting..."
           Title: "Write audio tracks"
           */
        messageBox( text, IDSTRPM_ALLOCSHAREDMEMERROR , sizeof(text),
                    title, IDSTRA_AUDIOWRITETITLE, sizeof(title),
                    RESSOURCEHANDLE, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
        writeLog("Can't allocate shared mem! Aborting...\n");  
        sendCommand("FREESHAREDMEM=1");
        WinPostMsg(hwnd,WM_CLOSE,0,0);
        return (MRESULT) TRUE;
      }
      /* Let the class free the shared mem. If this helper crashes and can't send a msg to the
         class the memory isn't blocked. */
      sendCommand("FREESHAREDMEM=1");
      bAbort=FALSE;
      iStatus=0;
      /* Add switch entry */
      memset(&swctl,0,sizeof(swctl));
      WinQueryWindowProcess(hwnd,&pid,NULL);
      swctl.hwnd=hwnd;
      swctl.uchVisibility=SWL_VISIBLE;
      swctl.idProcess=pid;
      swctl.bProgType=PROG_DEFAULT;
      swctl.fbJump=SWL_JUMPABLE;
      WinAddSwitchEntry(&swctl);

      /*sprintf(text,"%d",params[4]);*/ 
      //      sprintf(text,"params[4]: %d ulTrackS: %d",params[4],ulTrackSize);
      /* WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, pvSharedMem,
         params[4],
         0UL, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE );
         WinPostMsg(hwnd,WM_CLOSE,0,0);
         return (MRESULT) TRUE;
         */

      WinShowWindow(WinWindowFromID(hwnd,IDPB_STATUSOK),FALSE);
      WinShowWindow(WinWindowFromID(hwnd,IDPB_ABORTWRITE),TRUE);
      pbarProgressBarFromStatic(WinWindowFromID(hwnd, IDSR_PERCENT), PBA_ALIGNLEFT);
      /* Set percent bar value to zero */
      WinPostMsg(WinWindowFromID(hwnd,IDSR_PERCENT),WM_UPDATEPROGRESSBAR,MPFROMLONG(0),
                 MPFROMLONG(0));

      /* Title for dialog box */
      /* Text: "Writing audio CD" */
      getMessage(text, IDSTRPM_DAOTITLE, sizeof(text), RESSOURCEHANDLE , hwnd);
      WinSetWindowText(hwnd,text);

      /* Text: "Writing audio in DAO mode... */
      getMessage(text, IDSTRPM_DAOINFOTEXT, sizeof(text), RESSOURCEHANDLE , hwnd);
      WinSetWindowText(WinWindowFromID(hwnd,IDST_ACTIONTEXT),text);

      WinSetWindowPos(hwnd,HWND_TOP,0,0,0,0,SWP_ZORDER|SWP_ACTIVATE);
      /* First query free CD space */         
      queryFreeCDSpace(hwnd);
      return (MRESULT) TRUE;
    case WM_CLOSE:
      WinDismissDlg(hwnd,0);
      return FALSE;
    case WM_HELP:
      sprintf(text,"DISPLAYHELPPANEL=%d",IDDLG_WRITESTATUS);
      sendCommand(text);      
      break;
    case WM_COMMAND:
      switch(SHORT1FROMMP(mp1))
        {
        case IDPB_ABORTWRITE:
          /* User pressed the ABORT button */
          DosBeep(1000,200);
          WinPostMsg(hwnd,WM_CLOSE,0,0);
          break;
        case IDPB_STATUSOK:
          WinPostMsg(hwnd,WM_CLOSE,0,0);
          break;
        default:
          break;
        }
      break;
    case WM_APPTERMINATENOTIFY:
      if(1/*thisPtr*/) {
        switch(LONGFROMMP(mp1)) {
        case ACKEY_CDSIZE:
          /* This msg is sent by the helper prog after getting the actual free space of the inserted
             CD */
          /* Save CD-Size */
          lTemp=LONGFROMMP(mp2);//*2048;
          /* Delete previous Message in the listbox */
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_DELETEITEM,MPFROMSHORT(0),0);
          
          if(lTemp==0) {
            /* There was an unrecoverable error. 
               Display a message and exit */
            queryFreeCDSpaceError(hwnd);
            return FALSE;
          }
          lTemp/=75;
          /* Insert the CD size into the listbox to inform the user */
          /* Text: "Free CD space is %d.%0.2d min" */
          getMessage(text, IDSTRPM_DAOCDLENGTH, sizeof(text), RESSOURCEHANDLE , hwnd);

          sprintf(title, text,lTemp/60, lTemp%60);
          writeLog(title);
          writeLog("\n");
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(0),title);

          /* Check if user pressed 'Abort' */
          //if(checkAbort(hwnd,1))
          //  return FALSE;

          /* Put a message into the listbox */
          lTemp=(LONG)(ulTotalSize/2352/75);
          /* Text: "Audio length is %d.%0.2d" */
          getMessage(text, IDSTRPM_DAOAUDIOLENGTH, sizeof(text), RESSOURCEHANDLE , hwnd);          
          sprintf(title,text,lTemp/60, lTemp%60);
          writeLog(title);
          writeLog("\n");
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(1),
                    title );
          rc=MBID_YES;
          if(LONGFROMMP(mp2)<((LONG)ulTotalSize/2352)) {
            rc=messageBox( text, IDSTRPM_DAOAUDIOTOLONG, sizeof(text),
                           title, IDSTRPM_DAOWARNING, sizeof(title),
                           RESSOURCEHANDLE, HWND_DESKTOP, MB_YESNO | MB_ICONEXCLAMATION|MB_MOVEABLE);
          }
          if(rc==MBID_YES) {
            /* insert message in Listbox */
            /* Text: "Writing lead in..." */
            getMessage(text, IDSTRPM_LEADIN, sizeof(text), RESSOURCEHANDLE , hwnd);
            WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(2),
                       text );
            WinShowWindow(WinWindowFromID(hwnd,IDPB_ABORTWRITE),FALSE);
            WinShowWindow(WinWindowFromID(hwnd,IDSR_PERCENT),TRUE);
      
            writeDAO(hwnd);
          }
          else
            WinPostMsg(hwnd,WM_CLOSE,0,0);
          break;
        case ACKEY_MBWRITTEN:          
          lTemp=(LONG)(ulTotalSize/1024/1024);
          if(iStatus==0) {
            iStatus=1;
            /* insert message in Listbox */
            /* Text: "Writing audio data..." */
            getMessage(text, IDSTRPM_WRITINGAUDIO, sizeof(text), RESSOURCEHANDLE , hwnd);
            WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_DELETEITEM,MPFROMSHORT(2),0);
            WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(2),
                       text );
          }
          /* Update track percent bar value. The helper prog sends us the actual written MB. */
          //  WinPostMsg(WinWindowFromID(hwnd,IDSR_PERCENT),WM_UPDATEPROGRESSBAR,MPFROMSHORT(SHORT1FROMMP(mp2)+25),
          //           MPFROMLONG(lTemp+40));
          WinPostMsg(WinWindowFromID(hwnd,IDSR_PERCENT),WM_UPDATEPROGRESSBAR,MPFROMSHORT(SHORT1FROMMP(mp2)),
                     MPFROMLONG(lTemp));

          break;
        case ACKEY_LEADIN:          
          lTemp=(LONG)(ulTotalSize/1024/1024);
          /* Update track percent bar value. The helper prog sends us the actual written MB. */         
          /*  WinPostMsg(WinWindowFromID(hwnd,IDSR_PERCENT),WM_UPDATEPROGRESSBAR,MPFROMSHORT(SHORT1FROMMP(mp2)),
                     MPFROMLONG(lTemp+40));*/
          break;
        case ACKEY_LEADOUT:          
          lTemp=(LONG)(ulTotalSize/1024/1024);
          if(iStatus==1) {
            iStatus=2;
            /* insert message in Listbox */
            /* Text: "Writing lead out..." */
            getMessage(text, IDSTRPM_LEADOUT, sizeof(text), RESSOURCEHANDLE , hwnd);
            WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_DELETEITEM,MPFROMSHORT(2),0);
            WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(2),
                       text );
          }
          /* Update track percent bar value. The helper prog sends us the actual written MB. */         
          /*WinPostMsg(WinWindowFromID(hwnd,IDSR_PERCENT),WM_UPDATEPROGRESSBAR,
                     MPFROMSHORT(SHORT1FROMMP(mp2)+lTemp+25),MPFROMLONG(lTemp+40));
                     */

          break;
        case ACKEY_WRITEAUDIO:
          if(LONGFROMMP(mp2)==0) {
            DosBeep(1000,100);
            DosBeep(2000,100);
            DosBeep(3000,100);
            getMessage(text, IDSTRLB_CDROMCREATIONSUCCESS, sizeof(text), RESSOURCEHANDLE, hwnd);
            writeLog(text);
            writeLog("\n");
            /* Text: "CD-ROM successfully created." */
            /* Title: "Writing audio CD" */
            messageBox( text, IDSTRLB_CDROMCREATIONSUCCESS, sizeof(text),
                        title, IDSTRPM_DAOTITLE, sizeof(title),
                        RESSOURCEHANDLE, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);
          }
          else {
            DosBeep(100,500);
            /* Text: "Error while writing audio CD!" */
            /* Title: "Writing audio CD" */
            messageBox( text, IDSTRPM_DAOERROR, sizeof(text),
                        title, IDSTRPM_DAOTITLE, sizeof(title),
                        RESSOURCEHANDLE, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE); 
            /* Text:"Error while writing audio CD!" */
            getMessage(text, IDSTRPM_DAOERROR, sizeof(text), RESSOURCEHANDLE, hwnd);
            writeLog(text);
            writeLog("\n");
          }
          WinPostMsg(hwnd,WM_CLOSE,0,0);
          return (MRESULT)TRUE;
        default:
          break;
        }/* switch */
      }/* if(thisPtr) */           
      return WinDefWindowProc( hwnd, msg, mp1, mp2);
    default:
      break;
    }
    return WinDefDlgProc(hwnd, msg, mp1, mp2);    
}

BOOL checkSettings() 
{
  struct stat statBuf;
  BOOL bOk=TRUE;
  char text[CCHMAXPATH];
  char title[CCHMAXPATH];

  /* Check cdrdao path */
  if(stat(chrCdrdaoPath , &statBuf)==-1) {
    bOk=FALSE;
    /* text: "No valid cdrdao/2 path found in cdrecord.ini!"
       title: "Writing audio CD"
       */
    messageBox( text, IDSTRLOG_NOCDRDAO , sizeof(text),
                title, IDSTRPM_DAOTITLE, sizeof(title),
                RESSOURCEHANDLE, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);    
  }
  /* Check CDRecord/2 path */
  if(stat(chrCDRecord , &statBuf)==-1) {
    bOk=FALSE;
    /* text: "No valid CDRecord/2 path found in cdrecord.ini!"
       title: "Writing audio CD"
       */
    messageBox( text, IDSTRLOG_NOCDRECORD, sizeof(text),
                title, IDSTRPM_DAOTITLE, sizeof(title),
                RESSOURCEHANDLE, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);    
  }
  /* Check if cdrdao driver is given */
  if(strlen(chrCdrdaoDriver)==0) {
    bOk=FALSE;
    /* text: "No driver for cdrdao/2 found in cdrecord.ini!"
       title: "Writing audio CD"
       */
    messageBox( text, IDSTRLOG_NOCDRDAODRIVER , sizeof(text),
                title, IDSTRPM_DAOTITLE, sizeof(title),
                RESSOURCEHANDLE, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);    
  }


  return bOk;  
}

int main (int argc, char *argv[])
{
  /*  HWND hwndGrab; */
  HAB  hab;
  HMQ  hmq;
  QMSG qmsg;
  SWCNTRL  swctl={0};
  PID pid;
  HWND hwndFrame;
  short a;


  /* Create a copy of the args */
  /* argv[0]: progname
   * argv[1]: installdir of Audio-CD-Creator
   * argv[2]: foldername
   * argv[3]: # tracks
   * argv[4]: size of all tracks
   */
  numArgs=argc;
  for(a=0;a<argc;a++)
    {
      params[a]=argv[a];
    }
  
  hab=WinInitialize(0);
  if(hab) {
    hmq=WinCreateMsgQueue(hab,0);
    if(hmq) {  
      /* Check if user started prog by hand */   
      if(argc<5)
        pmUsage();
      else {
        /* Delete logfile */
        removeLog();
        writeLog("Starting to write audio CD\n\n");  
        /* Get our ressource dll */  
        RESSOURCEHANDLE=queryResModuleHandle();
        numTracks=atol(argv[3]); 
        ulTotalSize=atol(argv[4]);
        /* Load options from cdrecord.ini */
        readIni();
        /* if(readIni()) {*/
        if(checkSettings()) {        
          if( WinDlgBox( HWND_DESKTOP, NULLHANDLE, audioStatusDialogProc, RESSOURCEHANDLE, IDDLG_CHECKSTATUS, 0 ) == DID_ERROR )
            {
              if(pvSharedMem) {
                DosFreeMem(pvSharedMem);
              }      
              WinDestroyMsgQueue( hmq );
              WinTerminate( hab );
              DosBeep(100,600);
              sendCommand("FREESHAREDMEM=1");
              return( 1 );
            }        
          if(pvSharedMem) {
            DosFreeMem(pvSharedMem);
          }      
        }/* if(checkSettings()) */
        else
          sendCommand("FREESHAREDMEM=1");
        freeResHandle();
      }
      WinDestroyMsgQueue(hmq);
    }
    WinTerminate(hab);
  }
  return 0;
}









