/*
 * pmwrtimg.cpp (C) Chris Wohlgemuth 1999
 *
 * This helper handles the GUI stuff for image writing
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */          
#define INCL_DOS
#define INCL_DOSFILEMGR
#define INCL_DOSERRORS
#define INCL_WIN

#include <os2.h>

#include <sys\types.h>
#include <sys\stat.h>
#include <stdio.h>
#include <string.h>
#include "progbars.h"
#include "audiofolder.h"
#include "audiofolderres.h"


//#define DEBUG
extern char chrMkisofs[CCHMAXPATH];/* Path to mkisofs */
extern char chrMkisofsOptions[CCHMAXPATH];

extern char chrCDROptions[CCHMAXPATH];
extern char chrCDRecord[CCHMAXPATH];/* Path to cdrecord */
extern LONG  lCDROptions;
extern LONG lMKOptions;

PVOID pvSharedMem;
char * pipePtr;
char  logName[CCHMAXPATH]="pwrteimg.log";
int numArgs;
char* params[99+4];
  /* argv[0]: progname
   * argv[1]: installdir of Audio/Data-CD-Creator
   * argv[2]: folder
   * argv[3]: imagename
   */

HMODULE RESSOURCEHANDLE=0;

void sendCommand(PSZ command);
void removeLog();
void pmUsage();

/* This Proc handles the on-the-fly data CD writing */
MRESULT EXPENTRY writeImageStatusDialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  char text[CCHMAXPATH];
  char title[CCHMAXPATH];
  char *textPtr;
  char *textPtr2; 
  static LONG lCDSize;
  static LONG lImageSize;
  struct stat buf;
  SWCNTRL swctl;
  PID pid;

  switch (msg)
    {      
    case WM_INITDLG:   
      /* Text: "Writing image." */
      getMessage(text, IDSTRD_WRITEIMAGETITLE, sizeof(text), RESSOURCEHANDLE , hwnd);
      WinSetWindowText(hwnd,text);

      if(DosGetNamedSharedMem(&pvSharedMem,"\\SHAREMEM\\MKISOFSCMDLINE",PAG_READ|PAG_WRITE)) {
        WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, "Can't alloc shared mem! Aborting...",
                       "Writing image",
                       0UL, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE );
        sendCommand("FREESHAREDMEM=1");
        WinPostMsg(hwnd,WM_CLOSE,0,0);
        return (MRESULT) TRUE;
      }
      /* Tell folder to free the shared mem, so we have no problems if prog crashes */
      sendCommand("FREESHAREDMEM=1");

      /* Add switch entry */
      memset(&swctl,0,sizeof(swctl));
      WinQueryWindowProcess(hwnd,&pid,NULL);
      swctl.hwnd=hwnd;
      swctl.uchVisibility=SWL_VISIBLE;
      swctl.idProcess=pid;
      swctl.bProgType=PROG_DEFAULT;
      swctl.fbJump=SWL_JUMPABLE;
      WinAddSwitchEntry(&swctl);

      WinShowWindow(WinWindowFromID(hwnd,IDPB_STATUSOK),FALSE);
      WinShowWindow(WinWindowFromID(hwnd,IDPB_ABORTWRITE),TRUE);
      /*      sprintf(text,"1: %s, 2: %s, 3: %s",params[1],params[2],params[3]);
              WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, text,
              params[3],
              0UL, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE );
              */

      pbarProgressBarFromStatic(WinWindowFromID(hwnd, IDSR_PERCENT), PBA_ALIGNLEFT);
      /* Set percent bar value to zero */
      WinPostMsg(WinWindowFromID(hwnd,IDSR_PERCENT),WM_UPDATEPROGRESSBAR,MPFROMLONG(0),
                 MPFROMLONG(0));

      /* Title for dialog box */
      /* Text: "Writing image %s..." */
      getMessage(text, IDSTRD_WRITINGIMAGE, sizeof(text), RESSOURCEHANDLE , hwnd);
      sprintf(title,text,params[3]);
      WinSetWindowText(WinWindowFromID(hwnd,IDST_ACTIONTEXT),
                       title);

      WinSetWindowPos(hwnd,HWND_TOP,0,0,0,0,SWP_ZORDER|SWP_ACTIVATE);
      /* First query free CD space */         
      queryFreeCDSpace(hwnd);
  
      return (MRESULT) TRUE;
    case WM_CLOSE:
      WinDismissDlg(hwnd,0);
      return FALSE;
    case WM_COMMAND:
      switch(SHORT1FROMMP(mp1))
        {
        case IDPB_ABORTWRITE:
          /* User pressed the ABORT button */
          DosBeep(1000,200);
          WinPostMsg(hwnd,WM_CLOSE,0,0);
          break;
        case IDPB_STATUSOK:
          WinPostMsg(hwnd,WM_CLOSE,0,0);
          //WinPostMsg(WinQueryWindow(hwnd,QW_OWNER),WM_CLOSE,0,0);
          break;
        default:
          break;
        }
    case WM_APPTERMINATENOTIFY:
      if(1/*thisPtr*/) {
        switch(LONGFROMMP(mp1)) {
        case ACKEY_FIXATING:
          /* This msg. is sent by the helper process when cdrecord begins with fixating the disk */
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_DELETEITEM,MPFROMSHORT(2),0);
          if(LONGFROMMP(mp2)==0)
            sprintf(text,"Fixating... (may need some minutes)");
          else
            sprintf(text,"Writing buffers to CD...");
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(2),text);
          break;
        case ACKEY_MBWRITTEN:
          /* Update percent bar value. The helper prog sends us the actual written Mbytes. */
          WinPostMsg(WinWindowFromID(hwnd,IDSR_PERCENT),WM_UPDATEPROGRESSBAR,MPFROMLONG(LONGFROMMP(mp2)/1000),MPFROMLONG(lImageSize/1000));
          break;      
          //case ACKEY_ONTHEFLY:
        case ACKEY_WRITEONLY:
          /* Writing done. */
          if(!(LONGFROMMP(mp2))) {
            WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_DELETEITEM,MPFROMSHORT(2),0);
            sprintf(text,"CD-ROM successfully created.");
            WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(2),text);
            DosBeep(1000,100);
            DosBeep(2000,100);
            DosBeep(3000,100);
          }
          else {
            DosBeep(100,500);
            WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_DELETEITEM,MPFROMSHORT(2),0);
            sprintf(text,"Error while writing on the fly!");
            WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(2),text);
          }
          WinShowWindow(WinWindowFromID(hwnd,IDSR_PERCENT),FALSE);
          WinShowWindow(WinWindowFromID(hwnd,IDPB_STATUSOK),TRUE);
          WinSetWindowPos(hwnd,HWND_TOP,0,0,0,0,SWP_ZORDER|SWP_ACTIVATE);
          break;
        case ACKEY_PRINTSIZE:
          /* Query imagefile size */
          if(stat(params[3],&buf)) {
            WinMessageBox(  HWND_DESKTOP,   HWND_DESKTOP, "Sorry, file size unknown.",
                            "Write image, check size",
                            0UL, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE );
            WinPostMsg(hwnd,WM_CLOSE,0,0);
            break;
          }
          
          /* The PM wrapper requested the imagesize */

          /* Delete previous message in listbox */
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_DELETEITEM,MPFROMSHORT(1),0);
          /* Put new msg with imagesize into listbox */
          sprintf(text,"Imagesize is %d.%0.3d.%0.3d bytes",
                  buf.st_size/1000000,(buf.st_size%1000000)/1000,buf.st_size%1000);

          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(1),text);
          /* Save imagesize. We need it for the percent bar */
          lImageSize=buf.st_size;

          if(lImageSize >lCDSize) {
            WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, "Image is bigger than free CD space! Aborting...",
                           "On the fly writing",
                           0UL, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE );
            WinPostMsg(hwnd,WM_CLOSE,0,0);
            break;
          }
          if(strstr(pvSharedMem," -multi")) {
            if(lImageSize >(lCDSize-(11400*2048))) {
              WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, "Multisessionimage is to big for the CD! \
There is no space for the necessary lead out. Select singlesession instead.  \nAborting...",
                             "On the fly writing",
                             0UL, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE );
              WinPostMsg(hwnd,WM_CLOSE,0,0);
              break;
            } 
            
          }

          /* Check if user pressed Abort in the meantime */
          /* if(checkAbort(hwnd,2))
             break;
            */
          /* Now starting the write process */

          /* Put a message in the listbox */
          sprintf(text,"Image writing...");
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(2),text);
          /* Hide ABORT Button in the status dialog. We do not let the user interrupt a write because this
             will damage the CD. */
          WinShowWindow(WinWindowFromID(hwnd,IDPB_ABORTWRITE),FALSE);
          /* Set percent bar value */
          WinPostMsg(WinWindowFromID(hwnd,IDSR_PERCENT),WM_UPDATEPROGRESSBAR,MPFROMLONG(0),MPFROMLONG(lImageSize));
          /* Show percent bar which shows the write progress */
          WinShowWindow(WinWindowFromID(hwnd,IDSR_PERCENT),TRUE);

          /*          WinPostMsg(hwnd,WM_APPTERMINATENOTIFY,MPFROMLONG(ACKEY_ONTHEFLY),0);
          break;*/
          /* argv[0]: progname
           * argv[1]: installdir of Audio/Data-CD-Creator
           * argv[2]: folder
           * argv[3]: imagename
           */

          /*      WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, params[1],
                  params[1],
                  0UL, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE );
                  */
          launchWrapper("", params[1], hwnd,"writeimg.exe","CDRecord/2");
          break;

        case ACKEY_CDSIZE:
          /* This msg is sent by the helper prog after getting the actual free space of the inserted
             CD */
          /* Save CD-Size */
          lCDSize=LONGFROMMP(mp2)*2048;
          /* Delete previous Message in the listbox */
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_DELETEITEM,MPFROMSHORT(0),0);

          if(lCDSize==0) {
            /* There was an unrecoverable error. */
            queryFreeCDSpaceError(hwnd);
            return FALSE;
          }
          /* Insert the CD size into the listbox to inform the user */
          sprintf(text,"Free CD space is %d.%0.3d.%0.3d bytes",
                  LONGFROMMP(mp2)*2048/1000000,(LONGFROMMP(mp2)*2048%1000000)/1000,LONGFROMMP(mp2)*2048%1000);
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(0),text);
          
          /* Check if user pressed 'Abort' */
          //if(checkAbort(hwnd,1))
          //  return FALSE;

          /* Put a message into the listbox */
          WinSendMsg(WinWindowFromID(hwnd,IDLB_CHECKSTATUS),LM_INSERTITEM,MPFROMSHORT(1),
                    "Querying image size..." );
          WinPostMsg(hwnd,WM_APPTERMINATENOTIFY,MPFROMLONG(ACKEY_PRINTSIZE),0);
          break;
        default:
          break;
        }/* switch */
      }/* if(thisPtr) */           
      return WinDefWindowProc( hwnd, msg, mp1, mp2);
    default:
      break;
    }
    return WinDefDlgProc(hwnd, msg, mp1, mp2);    
}

BOOL checkSettings() 
{
  struct stat statBuf;
  BOOL bOk=TRUE;
  char text[CCHMAXPATH];
  char title[CCHMAXPATH];

  /* Check CDRecord/2 path */
  if(stat(chrCDRecord , &statBuf)==-1) {
    bOk=FALSE;
    /* text: "No valid CDRecord/2 path found in cdrecord.ini!"
       title: "Data-CD-Creator"
       */
    messageBox( text, IDSTRLOG_NOCDRECORD, sizeof(text),
                title, IDSTRD_DATACDCREATOR , sizeof(title),
                RESSOURCEHANDLE, HWND_DESKTOP, MB_OK | MB_ICONEXCLAMATION|MB_MOVEABLE);    
  }

  return bOk;  
}



int main (int argc, char *argv[])
{
  /*  HWND hwndGrab; */
  HAB  hab;
  HMQ  hmq;
  QMSG qmsg;

  HATOMTBL hatSystem;
  short a;

  ULONG fl;
  HWND hwndClient;

  /* Create a copy of the args */
  /* argv[0]: progname
   * argv[1]: installdir of Audio-CD-Creator
   * argv[2]: foldername
   * argv[3]: imagename
   */
  numArgs=argc;
  for(a=0;a<argc;a++)
    {
      params[a]=argv[a];
    }
  
  
  hab=WinInitialize(0);
  if(hab) {
    hmq=WinCreateMsgQueue(hab,0);
    if(hmq) {  
      /* Check if user started prog by hand */   
      if(argc<4)
        pmUsage();
      else {
        /* Get our ressource dll */  
        RESSOURCEHANDLE=queryResModuleHandle();     
        removeLog(); 
        /* Load grabber options from cdrecord.ini */
        readIni();
        if(checkSettings()) {
          if( WinDlgBox( HWND_DESKTOP, NULLHANDLE, writeImageStatusDialogProc, RESSOURCEHANDLE, IDDLG_CHECKSTATUS, 0) == DID_ERROR )
            {
              if(pvSharedMem) {
                DosFreeMem(pvSharedMem);
              }      
              WinDestroyMsgQueue( hmq );
              WinTerminate( hab );
              /*     if(hini)PrfCloseProfile(hini);*/
              DosBeep(100,600);
              return( 1 );
            }
          //DosBeep(5000,600);
          if(pvSharedMem) {
            DosFreeMem(pvSharedMem);
            // sendCommand("FREESHAREDMEM=1");
          }      
        }/* if(checkSettings()) */
        freeResHandle();
      }
      WinDestroyMsgQueue(hmq);
    }
    WinTerminate(hab);
  }
  return 0;
}









