:userdoc.

:docprof.

:title. Help for Audio-CD-Creator/Data-CD-Creator

:h1 res=001.Audio-CD-Creator V0.38
:i1 global.Audio-CD-Creator
:p.
Audio-CD-Creator helps you creating Audio-CDs with CDRecord/2 and cdrdao/2. It works also as a frontend for any grabber program.
As a folder subclass it uses features of the WPS like Drag and Drop and context menus. This version supports TAO- and DAO-mode.

:p.
Put the wavefiles you want to burn into this folder, 
arrange them in the desired order and press the write-button. It's possible to use shadows of wavefiles, too. The
folder follows the links and gives the right names to CDRecord/2 or cdrdao/2. It's also possible to write MPS3 files
without manual decoding to a CD when mpg123 (included) is properly setup.
Any other object is skipped while processing the
folder contents. So you can put dokumentation files, program objects and so on into this folder, too.
All options are set using the settings notebook of the folder object. Help is avaiable for most functions. Use the
right mouse button.
:p.
:link reftype=hd res=600.Main window help:elink.
:p.
This DLL and the accompaigning program are provided 'as is' under the terms of the Gnu Public Licence (GPL).
For further information read the file :link reftype=hd res=202.'COPYING':elink..
:p.
:link reftype=hd res=201.History:elink.
:p.
:note text='Author:'. Chris Wohlgemuth.
:note text='E-Mail:'. christopher.wohlgemuth@bch.siemens.de
:note text='WWW:'.    http&colon.&slr.&slr.www.geocities.com&slr.SiliconValley&slr.Sector&slr.5785&slr.
:p.

:h2 res=202.Licence
.im licence.inc

:h2 res=201.History
.im audiohistory.inc

:h2 res=900.Grab status window
:p.
This window shows the grab status. 
:p.
When pressing the :hp2.Break:ehp2. button the grabber process is terminated after the current track.
If you want to kill the process immediately chose the :hp2.Grab track:ehp2. window in the window list
and type CTRL-C in that window. If you selected several tracks the next track will be grabbed so it
may be necessary to click :hp2.Break:ehp2. prior to killing the process.

:h2 res=1200.Write status window
:p.
This window shows the write status. 
:p.
When pressing the :hp2.Break:ehp2. button the write process is terminated after the current track.
The process does not end immediately. The track will be properly written and closed to prevent
damaging the CD-R. Killing the write process during writing a track produces an unusable CD. It may
be necessary to manually fix the CD so an audio player can read it. Use CDR-Tools to do so.

.im generalsettings.inc

.im cdrecordsettings.inc

.im cdrdaosettings.inc

.im grabbersettings.inc

.im mpg123settings.inc

:h1 res=6601.CD/RW-Tools menu
:p.
Select this menu to show a dialog which gives you access to some functions helping you when working with
CD-Rs or CD-R/Ws. For example loading and unloading the media, blanking etc.


:h1 res=600.Main window
:p.
The Main window divides into three parts. 
:ul.
:li.The container behaves like any WPS-folder container. You can put objects into it as usual. But only wavefiles
and shadows of wavefiles are considered when writing CDs. So you can put documentation files into the folder to
keep all parts of a project together.

:li.At the top of the window you can switch between :link reftype=hd res=601.write-:elink. and 
:link reftype=hd res=602.grab-mode:elink.. When in grab-mode an entryfield pops up
where you can enter the name for the saved tracked.
:li.On the left side of the window you can change options for the selected mode. According to your mode selection
this part changes.  
:eul.

:h2 res=601.Write mode
:p.
In write mode you can select on the left side of the window the write options for audio-CDs. Order the wavefiles in
the container as desired and press :hp2.Write:ehp2.. A tracklist dialog pops up where you can check the files 
and confirm the write. After doing that CDRecord/2 is called to actually burn the CD. The whole setup for CDRecord/2
e.g. which drive to use is done in the settings notebook.
 
:h3 res=610.Pad check box
:p.
Check this box to make sure CDRecord/2 pads the given audio files where appropriate. Since data only can be
stored on the CD per sector which means a multiple of 1/75 sec it may be necessary to fill it up to sector
boundaries. This is done by inserting binary zeroes into the stream which means silence.

:h3 res=611.No fix check box
:p.
Check this box to leave the CD unfixed after writing the last selected track. This is necessary if you want to append
more tracks later. You can fix the CD using the CDR-Tools. Fixing the CD means writing the table of contents (TOC)
and closing it. Audio players can only read properly closed CDs.

:h3 res=612.Preemphasis check box
:p.
Some CDs are recorded with preemhasis. When grabbing tracks from such CDs the preemphasis is preserved. When
writing such wave files back on CD you have to tell CDRecord/2 to mark them as recorded with preemphasis. 

:h3 res=615.DAO check box
:p.
Check this if you want to write the CD in disk at once mode. Only when using DAO you can prevent the
insertion of a two second pause between each track. You have to install cdrdao/2 and provide the path to it
if you want to use this feature.
:note.You can't use MP3 files for writing when in DAO mode.

:h3 res=613.Test only check box
:p.
If checked the CD is written in test mode. This means all tasks are performed but the laser of the writer is turned of.
This is for example useful to check if the performance of the system is sufficient to write a CD while doing other tasks.

:h3 res=614.Write
:p.
Click this button to start the writing of the CD. A dialog pops up where you can check the wave files and
confirm the write. If you've checked 'Dummy' everything is done with write laser turned of.

:h2 res=602.Grab mode
:p.
In grab mode you have a listbox on the left side to choose the tracks you want to grab.
:ul.
:li.Press :link reftype=hd res=622.Refresh:elink. to
fill the listbox with the tracks of the inserted CD. Your grabbing drive and the grabber are specified in the settings
notebook.
:li.Choose the tracks you want to grab by clicking on them in the :link reftype=hd res=621.listbox:elink..
:li.Enter a name in the entryfield at
the top and press :hp2.Grab:ehp2..
:eul.
:p.
A status window pops up and the grabbing takes place in the background. A logfile named
:hp2.grab.log:ehp2. is created in the folder which contains any messages from :hp2.stderr:ehp2. of the grabber.
Examine it if anything goes wrong. You can close the folder while grabbing.

:h3 res=621.Tracks listbox 
:p.
The tracks listbox shows the audio tracks of the inserted CD. Press :link reftype=hd res=622.Refresh:elink. to update the contents.
This is necessary whenever you change the CD or after the opening of an Audio-CD-Creator folder.
You can select tracks for grabbing simply by clicking on them. Multiple selections are possible. Press :link reftype=hd 
res=624.Select all:elink. if you want to grab an entire CD.

:h3 res=622.Refresh button
:p.
Press this button to fill the :link reftype=hd res=621.tracks listbox:elink. with the tracks of the currently inserted CD.
This is necessary whenever you change the CD in the grab drive. You can also use this button to deselect currently selected
tracks in the tracks listbox.

:h3 res=623.Grab button
:p.
Press this button to start the grabbing of the selected tracks.

:h3 res=624.Select all button
:p.
Press this button to select all tracks of the inserted CD for grabbing. Clicking on a selected track deselects it.

:h2 res=603.Status line
:p.
The status line shows the total time of all tracks. It's important to know that the cd-writer inserts a pause of 
2 seconds between each two tracks. These pauses are not included in the shown time.







:h1 res=002.Data-CD-Creator V0.38
:i1 global.Data-CD-Creator
:p.
Data-CD-Creator helps you creating data-CDs with CDRecord/2. It shields you from the commandline syntax of
CDRecord/2 and mkisofs. As a folder subclass it uses features of the WPS like Drag and Drop and context menus.
:p.
It's possible to create singlesession- and multisession CDs. Choose the features you want in the settings notebook.
After putting folders and files you want to burn on CD into the folder press the 'Create image' button. Mkisofs
will be called with the options you've set. Afterwards select the 'Write-CD' button to write the created ISO-Image on
CD. The contents of the folder will be written into the root-directory of the CD.
:p.
Beside filesystem objects you can also put shadows into the folder
to create a virtual tree of files. When building the image
the linked to files and folders are searched. Only one level
of linkage is supported. That means shadows in
shadow-folders are ignored.
:p.
:link reftype=hd res=221.Main window help:elink.
:p.
This DLL and the accompaigning program are provided 'as is' under the terms of the Gnu Public Licence (GPL).
For further information read the file :link reftype=hd res=202.'COPYING':elink..
:p.
:link reftype=hd res=211.History:elink.
:p.
:note text='Author:'. Chris Wohlgemuth.
:note text='E-Mail:'. christopher.wohlgemuth@bch.siemens.de
:note text='WWW:'.    http&colon.&slr.&slr.www.geocities.com&slr.SiliconValley&slr.Sector&slr.5785&slr.
:p.

:h2 res=211.History
.im datahistory.inc

:h2 res=221.Main window help
.im datamainwindowhelp.inc

:h3 res=1610.Create image only
:p.
Use this option if you only want to create an image file contain your data. You may
burn this image later on a CDR after checking :hp2.Write only:ehp2..

:h3 res=1611.Write only
:p.
Select this check box if you want to write an already existing image on CDR. Use the
entryfield and the :hp2.browse:ehp2. button at the top to select the image file. After doing so
press the :hp2.write:ehp2. button. You may select :hp2.Dummy:ehp2. if you only want to do a test. 

:h3 res=1612.On the fly
:p.
When choosing :hp2.On the fly:ehp2. the data will be written directly on the CDR without
creating an intermediate image file. Be sure the performance of your system is sufficient
or a buffer underrun may occur causing the disk to be damaged. It's always a good idea to do
some tests in -dummy mode first to check the configuration.

:h3 res=1606.Settings
:p.
Choose this button to open the settings notebook of the Data-CD-Creator folder. In the notebook
you may change the type of CD you want to create, the filename options and the paths to
the helper applications like CDRecord/2 and mkisofs.

:h3 res=226.Test only
:p.
When selecting this option all writing is done in test mode. This means the laser of the writer
is turned off and no data is written on the CDR. This is useful to test the performance and
configuration of the machine to make sure a real write will be successful.

:h3 res=1502.Browse
:p.
Use this button to search an image file using the standard file dialog. If you know the name
and position of the file you may enter the full path directly into the entryfield.
:p.
If you want to create an image you may use the file dialog to find the location where
the file will be written to. Select the apropriate subdirectory and enter a filename into
the file dialog. After pressing :hp2.Ok:ehp2. the full path will be put into the entryfield.
If the file already exists the image will be overwritten.

:h3 res=1501.Imagename
:p.
Enter the full path to the imagefile into this field. If you want to write the image on
CD it's the source path.
:p.
If you want to create an image it's the destination path. If you select an already existing
filename, this image will be overwritten.

:h3 res=1607.Check size
:p.
Press this button to determine the size of the image file. If an already created file
should be written on the CD the size of this file is displayed in the status line. In the
other cases mkisofs is called to calculate the size.

.im cdtypesettings.inc

.im filenamesettings.inc

:h1 res=1700.Author
:p.
You may specify some information about the author of the CD on this page.
See the documentation coming with mkisofs for further information.

.im mkisofssettings.inc

:euserdoc.















