:h1 res=1400.Filename options

Specify the filename options for the files to be written to CD on this page. For more information on the meaning
of the options read the mkisofs documentation or click the items below. Keep in mind that the documentation
coming with mkisofs is usually more up to date.

:p.
If you want to create a CD readable with pure DOS don't check :hp2.-l:ehp2. and :hp2.-L:ehp2..
The other option shouldn't do any harm. This will create a CD with 8.3 names. When :hp2.-T:ehp2. is
selected every directory will contain a file with the long names of every shortened name.
:p.
CDs for W*n systems should have :hp2.-J:ehp2. enabled. This is also useful for OS/2 CDs. unfortunately 
CDFS.IFS seems to have a bug so some CDs created with this option are not completely readable. But you can
always access all files using the ISO (long)names. You have to
activate Joliet support for OS/2 by adding the :hp2./W:ehp2. switch to the CDFS.IFS statement in the config.sys.
:p.
In general you may activate all filename switches for OS/2 CDs. Rockridge extensions are only used on *nix sytems
but mkisofs needs them when merging sessions during creation of an image. If The :hp2./W:ehp2. switch is given you'll
see the Joliet names otherwise the ISO longnames.
:p.
For more information click on the links below.
:sl.
:li.:link reftype=hd res=1401.Allow 32 character filenames:elink.
:li.:link reftype=hd res=1402.Allow leading periods:elink.	
:li.:link reftype=hd res=1403.Generate Joliet filenames:elink.
:li.:link reftype=hd res=1404.Generate Rockridge extensions:elink.
:li.:link reftype=hd res=1405.Generate TRANS.TBL files:elink.
:li.:link reftype=hd res=1406.All files:elink.
:esl. 

:h2 res=1401.Allow 32 character filenames
:p.
From the mkisofs (V1.2b4) documentation:
:p.
-l Allow full 32 character filenames. Normally the ISO9660 filename will be in an 8.3 format 
which is compatible with MS-DOS, even though the ISO9660 standard allows filenames of up 
to 32 characters. If you use this option, the disc may be difficult to use on a MS-DOS system, 
but this comes in handy on some other systems (such as the Amiga). Use with caution.

:h2 res=1402.Allow leading periods
:p.
From the mkisofs (V1.2b14) documentation:
:p.
-L Allow filenames to begin with a period. Usually, a leading dot is replaced with an underscore 
in order to maintain MS-DOS compatibility. 

:h2 res=1403.Generate Joliet filenames
:p.
From the mkisofs (V1.2b14) documentation:
:p.
-J Generate Joliet directory records in addition to regular iso9660 file names. This is primarily 
useful when the discs are to be used on Windows-NT or Windows-95 machines. The Joliet 
filenames are specified in Unicode and each path component can be up to 64 Unicode characters long.

:h2 res=1404.Generate Rockridge extensions
:p.
You have to select Rockridge extension if you want to create a multisession CD.
:p.
From the mkisofs (V1.2b14) documentation:
:p.
-r This is like the -R option, but file ownership and modes are set to more useful values. The uid 
and gid are set to zero, because they are usually only useful on the author's system, and not 
useful to the client. All the file read bits are set true, so that files and directories are globally 
readable on the client. If any execute bit is set for a file, set all of the execute bits, so that exe- 
cutables are globally executable on the client. If any search bit is set for a directory, set all of 
the search bits, so that directories are globally searchable on the client. All write bits are 
cleared, because the CD-Rom will be mounted read-only in any case. If any of the special 
mode bits are set, clear them, because file locks are not useful on a read-only file system, and 
set-id bits are not desirable for uid 0 or gid 0. 

:h2 res=1405.Generate TRANS.TBL files
:p.
From the mkisofs (V1.2b14) documentation:
:p.
-T Generate a file TRANS.TBL in each directory on the CDROM, which can be used on non-Rock 
Ridge capable systems to help establish the correct file names. There is also information 
present in the file that indicates the major and minor numbers for block and character devices, 
and each symlink has the name of the link file given.

:h2 res=1406.All files
:p.
From the mkisofs (V1.2b14) documentation:
:p.
-a Include all files on the iso9660 filesystem.  Normally files  that  contain the characters '~' or '#'
will not be included (these are typically backup files for  editors under unix).

:p.Remember that W*n95 shortnames usually contain a '~'. so if you want to backup files of a
W*n partition it's probably necessary to have this option set.
