/*
 * cdsize.exe (C) Chris Wohlgemuth 1999
 *
 * This helper calculates the free space on a CDR and sends it
 * to the creator folder class
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#define  INCL_DOS
#define INCL_DOSQUEUES   /* Queue values */
 
#include <os2.h>
#include <process.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define PIPESIZE 2560
#define HF_STDOUT 1      /* Standard output handle */
#define HF_STDERR 2

int main(int argc, char * argv[])
{
  int rc;
  HFILE hfNew;
  HWND hwndNotify;
  char *text,*text2;
  PVOID pvSharedMem;
  HPIPE hpR, hpW;
  ULONG cbRead, cbWritten;
  CHAR achBuf[PIPESIZE], szFailName[CCHMAXPATH];
  HFILE hfSave;
  int iLeadin;
  int iLeadout;
  int size;

  rc=-1;
  iLeadin=0;
  iLeadout=0;
  hwndNotify=atol(argv[1]);

  //  if(DosGetNamedSharedMem(&pvSharedMem,"\\SHAREMEM\\MKISOFSCMDLINE",PAG_READ|PAG_WRITE))
  //{
  text=(char*)pvSharedMem;
  sprintf(szFailName,"%s %s -toc -v",argv[2],argv[3]);
  text=szFailName; 
  printf("Command is: %s\n",text);
  /* start  */

  /* Redirect stdout */ 
  hfSave = -1;// Get new handle
  hfNew = HF_STDOUT;
 
  if(!DosDupHandle(HF_STDOUT, &hfSave)){    /* Saves standard  handle      */
    //if(!DosCreatePipe(&hpR, &hpW, strlen(text)+CCHMAXPATH*20)){ /* Creates pipe            */
    if(!DosCreatePipe(&hpR, &hpW, PIPESIZE)){ /* Creates pipe            */

      /* If the pipe size is smaller than the output of the child the system() call blocks.
         So create the pipe big enough. */
      
      if(!DosDupHandle(hpW, &hfNew)){           /* Duplicates standard output handle */
  
        rc=system(text);

        DosClose(hpW);                       /* Closes write handle to ensure     */
        /* Notification at child termination */
        DosDupHandle(hfSave, &hfNew);        /* Brings stdout back                */

        /*
         * Read from the pipe and write to the screen
         * as long as there are bytes to read.
         */
          
        do {
          DosRead(hpR, achBuf, sizeof(achBuf), &cbRead);
          //DosWrite(HF_STDOUT, achBuf, cbRead, &cbWritten);
          text=strstr(achBuf,"ATIP");
          if(text){
            /* Check if we have a lead in section */
            text2=strstr(text,"in:");
            if(text2) {
              /* Yes, we have a lead in. Seems to be a blank disk. Find lead out now */
              iLeadin=0;
              text2++;
              text=strstr(text2,"ATIP");/* Second ATIP shows lead out of blank disk */
              if(text)
                sscanf(text,"%[^:]: %ld",szFailName,&iLeadout);
            }/* if(text2) */
            else {
              /* No lead in section. It seems to be a disk with some tracks already written */
              sscanf(text,"%[^:]: %ld",szFailName,&iLeadout); /* ATIP shows disk lead out */
              text2=strstr(text,"lout");
              if(!text2){/* Error */
                iLeadin=iLeadout;/* Set disk size to zero as error */
                break;
              }
              /* Lead out of track is lead in of next track */
              sscanf(text2,"%[^:]: %ld",szFailName,&iLeadin);
            }
          }
        } while(cbRead);          
        printf("Leadin is  %d \n",iLeadin); /* We use stdout because stderr is redirected */
        printf("Leadout is  %d \n",iLeadout);
        DosClose(hpR);
      }
    }
  }/* if(!DosDupHandle(HF_STDERR, &hfSave)) */      
  //   DosFreeMem(pvSharedMem);
  //}
  /* Calculate free space */
  size=iLeadout-iLeadin;
  if(iLeadin) {
    /* Because iLeadin isn't zero, the disk seems to be a disk with already written session.
       11400 sectors must be substracted from the size as lead in for the next session */
    if(size<11400)
      size=0;
    else
      size-=11400;
  }
  printf("Errorcode from cdrecord is: %d\n",rc);
  /* Send msg. to the notification window */
  WinPostMsg(hwndNotify,WM_APPTERMINATENOTIFY,MPFROMLONG(4),MPFROMLONG(size));
}










