/*
 * mp3dec.exe (C) Chris Wohlgemuth 1999
 *
 * This helper starts mpg123 for decoding a mp3 file.
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#define  INCL_DOS
#define INCL_DOSQUEUES   /* Queue values */
 
#include <os2.h>
#include <process.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "audiofolder.h" // For ACKEY_*

#define PIPESIZE 512
#define HF_STDOUT 1      /* Standard output handle */
#define HF_STDERR 2

//#define DEBUG

void message()
{
  printf("This program is (C) Chris Wohlgemuth 1999\n");
  printf("See the file COPYING for the license.\n\n");
  printf("This program should only be called by the CD-Creater WPS classes.\n");
}


int main(int argc, char * argv[])
{
  int rc;
  HWND hwndNotify;
  char *text,*text2;
  CHAR szCommand[CCHMAXPATH*4]={0};
  UCHAR loadError[CCHMAXPATH+4]= {0};
  int a;
  int min,sec,totalMin,totalSec;
  long done;

  HFILE hfNew2;
  HPIPE hpR2, hpW2;

  HFILE hfSaveError;

  char achBuf2[PIPESIZE];
  ULONG cbRead2, cbWritten;
 
  char achBuf[PIPESIZE];
  ULONG cbRead;
  RESULTCODES ChildRC= {0};
  PID pidChild;

  rc=-1;

  if(argc==1) {
    message();
    exit(-1);
  }
  
  hwndNotify=atol(argv[1]);

  printf(argv[0]);
  printf(" started with the following parameters: \n\n");
  for(a=0;a<argc;a++) {
    printf(argv[a]);
    printf("\n");
  }


  //  sprintf(szCommand,"\"%s\" -s \"%s\" 1>\"%s\\dec_mp3.raw\"",argv[4],argv[5],argv[3]);

  sprintf(loadError,"%s","cmd.exe");
  text=strrchr(loadError,0);
  text++;
  sprintf(szCommand,"/C \"\"%s\" -s \"%s\" 1> \"%s\\dec_mp3.raw\"\"",argv[4],argv[5],argv[3]);
  strcat(text,szCommand);
  printf("\nCommand is: %s\n",loadError);
  printf("\nparams: %s\n",szCommand);
  text=loadError;

  /* start  */
#ifdef DEBUG
  WinPostMsg(hwndNotify,WM_APPTERMINATENOTIFY,MPFROMLONG(ACKEY_MP3DECODE),MPFROMLONG(0));
  exit(0);
#endif  
  
  fflush(stdout);
  fflush(stderr);

  hfSaveError = -1;// Get new handle
  hfNew2 = HF_STDERR;
  
  if(!DosDupHandle(HF_STDERR, &hfSaveError)) {
    if(!DosCreatePipe(&hpR2, &hpW2, PIPESIZE)) {
      if(!DosDupHandle(hpW2, &hfNew2)){/* Duplicates standard error handle */

        /* Start mpg123 */
        rc=DosExecPgm(loadError,sizeof(loadError),EXEC_ASYNCRESULT, text,NULL,&ChildRC,text);
        //sprintf(achBuf,"DosExecPgm() for mpg123 returned: %d\n",rc);
        /*if(fh)
          fputs(achBuf,fh);*/
            
        DosClose(hpW2);                       /* Closes write handle to ensure     */
        /* Notification at child termination */


        DosDupHandle(hfSaveError, &hfNew2);        /* Brings stderr back                */   

        //pipe=popen(pipePtr,"wb");

        /*
         * Read from the pipe and write
         */          
        do {
          /* Read from mpg123 */
          DosRead(hpR2, achBuf2, sizeof(achBuf2), &cbRead2);
          rc=sscanf(achBuf2,"[%d:%d]  Remaining: [%*d:%*d]  Total: [%d:%d]",&min,&sec,&totalMin,&totalSec);
          DosWrite(HF_STDERR, achBuf2, cbRead2, &cbWritten);
          if(rc==4) {
            //sprintf(loadError,"tm: %d ts: %d : \n",totalMin,totalSec);
            //DosWrite(HF_STDERR, loadError, strlen(loadError), &cbWritten);
            done=(LONG)(min*60+sec)*100;
            if((totalMin*60+totalSec)>0)
              done/=(totalMin*60+totalSec);
            WinPostMsg(hwndNotify,WM_APPTERMINATENOTIFY,MPFROMLONG(ACKEY_MBWRITTEN),MPFROMLONG(done));
          }
          /* Write output of mkisofs */
          /*if(cbRead2)
            fwrite(achBuf2,sizeof(BYTE),cbRead2,pipe); */
                    
        } while(cbRead2);
        DosClose(hpR2);
      }
    }
  }/* if(!DosDupHandle(HF_STDERR, &hfSave)) */
  DosWaitChild(0,DCWW_WAIT,&ChildRC,&pidChild,0);  
  /*      if(fh) {*/
  sprintf(achBuf,"\nmpg123 returned: %d\n",ChildRC.codeResult);

          /*       fputs(achBuf,fh);
          fclose(fh);
          }*/
  fprintf(stderr,achBuf);

  WinPostMsg(hwndNotify,WM_APPTERMINATENOTIFY,MPFROMLONG(ACKEY_MP3DECODE),MPFROMLONG(ChildRC.codeResult));
  exit(0);

}










