/*
 * mp3size.exe (C) Chris Wohlgemuth 1999
 *
 * This helper starts mpg123 to query the playtime of the mp3 and sends it
 * to the audio folder class
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#define  INCL_DOS
#define INCL_DOSQUEUES   /* Queue values */
 
#include <os2.h>
#include <process.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "audiofolder.h" // For ACKEY_*

#define PIPESIZE 2560
#define HF_STDOUT 1      /* Standard output handle */
#define HF_STDERR 2

//#define DEBUG

int main(int argc, char * argv[])
{
  int rc;
  HFILE hfNew;
  HWND hwndNotify;
  char *text,*text2;
  HPIPE hpR, hpW;
  ULONG cbRead, cbWritten;
  CHAR achBuf[PIPESIZE], szFailName[CCHMAXPATH*4];
  HFILE hfSave;
  LONG size;

  rc=-1;
  hwndNotify=atol(argv[1]);

  printf(argv[0]);
  printf(" started with the following parameters: \n\n");
  for(size=0;size<argc;size++) {
    printf(argv[size]);
    printf("\n");
  }

#ifdef DEBUG
  WinPostMsg(hwndNotify,WM_APPTERMINATENOTIFY,MPFROMLONG(ACKEY_PLAYTIME),MPFROMLONG(size));
  exit(0);
#endif  

  sprintf(szFailName,"\"%s\" -n1 \"%s\"",argv[3],argv[4]);
  text=szFailName; 
  printf("\nmpg123 command is: %s\n",text);
  /* start  */

  /* Redirect stderr */ 
  hfSave = -1;// Get new handle
  hfNew = HF_STDERR;
 
  if(!DosDupHandle(HF_STDERR, &hfSave)){    /* Saves standard  handle      */
    if(!DosCreatePipe(&hpR, &hpW, PIPESIZE)){ /* Creates pipe            */

      /* If the pipe size is smaller than the output of the child the system() call blocks.
         So create the pipe big enough. */
      
      if(!DosDupHandle(hpW, &hfNew)){           /* Duplicates standard error handle */
        
        /* Start mpg123. The call returns after mpg123 ended */
        rc=system(text);
        if(rc!=-1) {
          DosClose(hpW);                       /* Closes write handle to ensure     */
          /* Notification at child termination */
          DosDupHandle(hfSave, &hfNew);        /* Brings stderr back                */
          
          /*
           * Read from the pipe and write to the screen
           * as long as there are bytes to read.
           */
          
          do {
            DosRead(hpR, achBuf, sizeof(achBuf), &cbRead);
            DosWrite(HF_STDOUT, achBuf, cbRead, &cbWritten);
            text=strstr(strlwr(achBuf),"total");
            if(text){                     
              text2=strchr(text,'[');
              if(text2) {
                text2++;
                size=strtol(text2,&text,0);
                size*=60;
                if(!(text==text2 || errno!=0)) {
                  text++;
                  size+=strtol(text,&text2,0);
                }
              }/* if(text2) */
            }
            
          } while(cbRead);          
          DosClose(hpR);
        }
      }
    }/* if(!DosDupHandle(HF_STDERR, &hfSave)) */      
  }/* End of if(rc!=-1) */
 
  printf("Errorcode from mpg123 is: %d\n",rc);
  printf("Size in secs: %d\n",size);
  size*=4*44100;/* Bytes */
  if(rc)
    size=0;/* Indicate error */
  /* Send msg. to the notification window */
  WinPostMsg(hwndNotify,WM_APPTERMINATENOTIFY,MPFROMLONG(ACKEY_PLAYTIME),MPFROMLONG(size));
}










